<?php
##############################################################
# FILENAME  : acp_rivals_edit_brackets.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

define ( 'MOVE_RIGHT', 1 );
define ( 'MOVE_LEFT', 2 );
define ( 'MOVE_UP', 3 );
define ( 'MOVE_DOWN', 4 );

/**
 * Edit Brackets
 * Called from acp_rivals with mode == 'edit_brackets'
 */
function acp_rivals_edit_brackets ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpbb_admin_path, $phpEx;

	$ladder		= new ladder ( );
	$clan		= new clan ( );
	$tournament	= new tournament ( );

	$submit			= request_var ( 'submit', '' );
	$tournament_id	= request_var ( 'tournament_id', 0 );

	// Are we submitting a form?
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form.
		$move			= request_var ( 'move', MOVE_RIGHT );
		$where			= request_var ( 'where', 0 );
		$clan_1			= request_var ( 'clan_1', 0 );
		$clan_2			= request_var ( 'clan_2', 0 );
		$position		= request_var ( 'position', 0 );
		$bracket		= request_var ( 'bracket', 0 );
		$remove_clan	= request_var ( 'remove_clan', 0 );

		// Check to see if we are removing a clan from the brackets.
		if ( $remove_clan != 0 )
		{
			// Remove the clan from the bracket.
			$tournament->remove_clan ( $remove_clan );

			// Completed. Let the user know.
			trigger_error ( 'REMOVE_CLAN_TOURNAMENT' );
		}

		// From winner bracket or looser brackets 1 = Winner, else = Looser.
		if ( $where == 1 )
		{
			if ( $tournament->data[ 'tournament_type' ] == 1 )
			{
				// Single elimination tournament.
				if ( $move == MOVE_RIGHT )
				{
					// Move the winner clan in the brackets.
					$sql_array	= array (
						'clan_tournament' => $tournament_id,
						'clan_id' => $clan_1,
						'clan_bracket' => $bracket + 1,
						'clan_position' => round ( $position / 2 )
					);
					$sql	= "INSERT INTO " . TCLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );print $sql;
					$db->sql_query ( $sql );

					// Add the looser clan to the finishedclans. Removes them from the tournament.
					$tournament_finishedclans		= unserialize ( $tournament->data[ 'tournament_finishedclans' ] );
					$tournament_finishedclans[ ]	= $clan_2;
					$tournament_finishedclans		= serialize ( $tournament_finishedclans );

					// Update the tournament data.
					$sql	= "UPDATE " . TOURNAMENTS_TABLE . " SET tournament_finishedclans = '$tournament_finishedclans' WHERE tournament_id = " . $tournament_id;
					$db->sql_query ( $sql );
				}
				else if ( $move == MOVE_LEFT )
				{
					// Move the clan back into its old position. Simple.
					$sql	= "DELETE FROM " . TCLANS_TABLE . " WHERE clan_id = $clan_1 AND clan_bracket = $bracket AND clan_position = $position AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
				}
				else
				{
					// Move the clan up or down. Get the clan above/below!
					$aob	= ( $move == MOVE_UP ) ? ( $position - 1 ) : ( $position + 1 );
					$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_bracket = $bracket AND clan_position = $aob AND clan_tournament = " . $tournament_id;
					$result	= $db->sql_query ( $sql );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					// Now, switch their positions.
					$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = {$row[ 'clan_position' ]} WHERE clan_id = $clan_1 AND clan_bracket = $bracket AND clan_position = $position AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
					$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = $position WHERE clan_id = {$row[ 'clan_id' ]} AND clan_bracket = $bracket AND clan_position = {$row[ 'clan_position' ]} AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
				}
			}
			else
			{
				// Double elimination tournament.
				if ( $move == MOVE_RIGHT )
				{
					// Move the winner clan in the brackets.
					$sql	= "INSERT INTO " . TCLANS_TABLE . " (clan_tournament, clan_id, clan_bracket, clan_position) VALUES ($tournament_id, $clan_1, " . ( $bracket + 1 ) . ", " . ( round ( $position / 2 ) ) . ")";
					$db->sql_query ( $sql );

					// Get the next spot to use for the looser bracket.
					$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_tournament = $tournament_id AND clan_bracket = 1 ORDER BY clan_position DESC";
					$result	= $db->sql_query_limit ( $sql, 1 );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					// Move the looser clan into the looser bracket.
					$position	= ( $row[ 'clan_position' ] > 0 ) ? $row[ 'clan_position' ] : 0;

					$sql_array	= array (
						'clan_tournament' => $tournament_id,
						'clan_id' => $clan_2,
						'clan_looser' => 1,
						'clan_bracket' => 1,
						'clan_position' => $row[ 'clan_position' ] + 1
					);
					$sql		= "INSERT INTO " . TCLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
					$db->sql_query ( $sql );
				}
				else if ( $move == MOVE_LEFT )
				{
					// Move the clan back into its old position. Simple.
					$sql	= "DELETE FROM " . TCLANS_TABLE . " WHERE clan_id = $clan_1 AND clan_bracket = $bracket AND clan_position = $position AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
				}
				else
				{
					// Move the clan up or down. Get the clan above/below!
					$aob	= ( $move == MOVE_UP ) ? ( $position - 1 ) : ( $position + 1 );
					$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_bracket = $bracket AND clan_position = $aob AND clan_tournament = " . $tournament_id;
					$result	= $db->sql_query ( $sql );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					// Now, switch their positions.
					$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = {$row[ 'clan_position' ]} WHERE clan_id = $clan_1 AND clan_bracket = $bracket AND clan_position = $position AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
					$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = $position WHERE clan_id = {$row[ 'clan_id' ]} AND clan_bracket = $bracket AND clan_position = {$row[ 'clan_position' ]} AND clan_tournament = " . $tournament_id;
					$db->sql_query ( $sql );
				}
			}

			// Check if a PM needs to be sent, only to losing and advancing clans.
			if ( $move == MOVE_RIGHT )
			{
				// Send a PM nofitfing both clans.	
				$subject	= $user->lang[ 'PM_TOURNAMENT' ];
				$message	= sprintf ( $user->lang[ 'PM_TOURNAMENTMSG' ], $tournament->data ( 'tournament_name', $tournament_id ) );
				insert_pm ( $clan->data ( 'clan_owner', $clan_1 ), $user->data, $subject, $message );

				$subject	= $user->lang[ 'PM_TOURNAMENT' ];
				$message	= sprintf ( $user->lang[ 'PM_TOURNAMENTMSG2' ], $tournament->data ( 'tournament_name', $tournament_id ) );
				insert_pm ( $clan->data ( 'clan_owner', $clan_2 ), $user->data, $subject, $message );
			}

			// Completed. Let the user know.
			trigger_error ( 'TOURNAMENT_UPDATED' );
		}
		else
		{
			if ( $move == MOVE_RIGHT )
			{
				// Move the winner clan from the looser bracket into the next bracket.
				$sql_array	= array (
					'clan_tournament' => $tournament_id,
					'clan_id' => $clan_1,
					'clan_bracket' => $bracket + 1,
					'clan_position' => round ( $position / 2 ),
					'clan_looser' => 1
				);
				$sql		= "INSERT INTO " . TCLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
				$db->sql_query ( $sql );

				// Add the looser clan to the finishedclans. Removes them from the tournament.
				$tournament_finishedclans	= $tournament->data ( 'tournament_finishedclans', $tournament_id ) . '|' . $clan_2;

				// Update the tournament data.
				$sql	= "UPDATE " . TOURNAMENTS_TABLE . " SET tournament_finishedclans = '$tournament_finishedclans' WHERE tournament_id = " . $tournament_id;
				$db->sql_query ( $sql );
			}
			else if ( $move == MOVE_LEFT )
			{
				// Move the clan back into its old position. Simple.
				$sql	= "DELETE FROM " . TCLANS_TABLE . " WHERE clan_id = $clan_1 WHERE clan_bracket = $bracket AND clan_position = $position AND clan_looser = 1 AND clan_tournament = " . $tournament_id;
				$db->sql_query ( $sql );
			}
			else
			{
				// Move the clan up or down. Get the clan above/below!
				$aob	= ( $move == MOVE_UP ) ? ( $position - 1 ) : ( $position + 1 );
				$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_bracket = $bracket AND clan_position = $aob AND clan_looser = 1 AND clan_tournament = " . $tournament_id;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$db->sql_freeresult ( $result );

				// Now, switch their positions.
				$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = {$row[ 'clan_position' ]} WHERE clan_id = $clan_1 AND clan_bracket = $bracket AND clan_position = $position AND clan_looser = 1 AND clan_tournament = " . $tournament_id;
				$db->sql_query ( $sql );
				$sql	= "UPDATE " . TCLANS_TABLE . " SET clan_position = $position WHERE clan_id = {$row[ 'clan_id' ]} AND clan_bracket = $bracket AND clan_position = {$row[ 'clan_position' ]} AND clan_looser = 1 AND clan_tournament = " . $tournament_id;
				$db->sql_query ( $sql );
			}

			// Check if a PM needs to be sent, only to losing and advancing clans.
			if ( $move == MOVE_RIGHT )
			{
				// Send a PM nofitfing both clans.
				$subject	= $user->lang[ 'PM_TOURNAMENT' ];
				$message	= sprintf ( $user->lang[ 'PM_TOURNAMENTMSG' ], $tournament->data ( 'tournament_name', $tournament_id ) );
				insert_pm ( $clan->data ( 'clan_owner', $clan_1 ), $user->data, $subject, $message );

				$subject	= $user->lang[ 'PM_TOURNAMENT' ];
				$message	= sprintf ( $user->lang[ 'PM_TOURNAMENTMSG2' ], $tournament->data ( 'tournament_name', $tournament_id ) );
				insert_pm ( $clan->data ( 'clan_owner', $clan_2 ), $user->data, $subject, $message );
			}

			// Completed. Let the user know.
			trigger_error ( 'TOURNAMENT_UPDATED' );
		}
	}
	else
	{
		// Generate the admin editable tournament.
		$tournament->generate_tournament ( true, $u_action );

		// Get the reports for this tournament.
		$sql	= "SELECT * FROM " . TREPORTS_TABLE . " WHERE report_tournament = $tournament_id ORDER BY report_time DESC";
		$result	= $db->sql_query ( $sql );

		$i	= 0;
		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			// Assign each report to the template.
			$template->assign_block_vars ( 'block_reports', array (
				'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2',
				'REPORT_ID' => $row[ 'report_id' ],
				'CLAN1' => $row[ 'clan_1' ],
				'CLAN2' => $row[ 'clan_2' ],
				'CLANR1' => $row[ 'clan_r1' ],
				'CLANR2' => $row[ 'clan_r2' ],
				'TIME' => $user->format_date ( $row[ 'report_time' ] ),
				'READY' => ( !empty ( $row[ 'clan_r1' ] ) && !empty ( $row[ 'clan_r2' ] ) ) ? $user->lang[ 'READY' ] : $user->lang[ 'NOT_READY' ] )
			);

			$i++;
		}

		$db->sql_freeresult ( $result );
	}
}

?>
