<?php
##############################################################
# FILENAME  : acp_rivals_edit_clans.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Edit Clans
 * Called from acp_rivals with mode == 'edit_clans'
 */
function acp_rivals_edit_clans ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpbb_admin_path, $phpEx;

	$clan		= new clan ( );
	$ladder		= new ladder ( );
	$tournament	= new tournament ( );

	$submit		= request_var ( 'submit', '' );
	$clan_id	= request_var ( 'clan_id', 0 );

	// Are we submitting a form?
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form.
		$clan_delete	= request_var ( 'clan_delete', 0 );
		if ( $clan_delete != 0 )
		{
			// Reset the user's session.
			$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = 0 WHERE user_id = " . $clan->data ( 'clan_owner', $clan_id );
			$db->sql_query ( $sql );

			// Delete the clan.
			$sql	= "DELETE FROM " . CLANS_TABLE . " WHERE clan_id = " . $clan_id;
			$db->sql_query ( $sql );

			// Delete the clan's data.
			$sql	= "DELETE FROM " . CLANDATA_TABLE . " WHERE clan_id = " . $clan_id;
			$db->sql_query ( $sql );

			// Delete all the members too.
			$sql	= "DELETE FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = " . $clan_id;
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'CLAN_UPDATED' );
		}

		// Check to see if they are adding to a ladder.
		$add_to_ladder	= request_var ( 'add_to_ladder', 0 );
		if ( $add_to_ladder != 0 )
		{
			// Add the clan to the ladder.
			$sql		= "SELECT MAX(clan_current_rank) AS current_rank FROM " . CLANDATA_TABLE . " WHERE clan_ladder = " . $add_to_ladder;
			$result		= $db->sql_fetchrow ( $sql );
			$row		= $db->sql_fetchrow ( $result );
			$db->sql_freeresult ( $result );
			$new_rank	= $row[ 'current_rank' ] + 1;

			$sql_array	= array (
				'clan_id' => $clan_id,
				'clan_ladder' => $add_to_ladder,
				'clan_score' => 1200,
				'clan_current_rank' => $new_rank,
				'clan_best_rank' => $new_rank,
				'clan_worst_rank' => 0,
				'clan_last_rank' => 0
			);
			$sql		= "INSERT INTO " . CLANDATA_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'CLAN_UPDATED' );
		}

		// Check to see if they are adding to a tournament.
		$add_to_tournament	= request_var ( 'add_to_tournament', 0 );
		if ( $add_to_tournament != 0 )
		{
			// Check if the clan is joined to the ladder the tournament is in.
			$clan_data	= $clan->data ( '*', $clan_id );
			if ( $tournament->data ( 'tournament_ladder', $add_to_tournament ) != 0 && !in_array ( $tournament->data ( 'tournament_ladder', $add_to_tournament ), $clan_data[ 'clan_ladders' ]  ) )
			{
				// They are not. Let the user know.
				trigger_error ( 'CLAN_NOTSIGNED_UP_LADDER' );
			}

			// Add them to the tournament.
			$sql_array	= array (
				'clan_tournament' => $add_to_tournament,
				'clan_id' => $clan_id,
				'clan_bracket' => 1,
				'clan_position' => 0
			);
			$sql		= "INSERT INTO " . TCLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
			$db->sql_query ( $sql );

			// Add the tournament to the clan's data.
			$tournaments	= unserialize ( $clan->data ( 'clan_tournaments', $clan_id ) );
			$tournaments[ ]	= $add_to_tournament;
			$tournaments	= serialize ( $tournaments );

			$sql	= "UPDATE " . CLANS_TABLE . " SET clan_tournaments = '$tournaments' WHERE clan_id = " . $clan_id;
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'CLAN_UPDATED' );
		}

		// Check to see if they are moving the clan.
		$move_ladder		= request_var ( 'move_ladder', 0 );
		$move_from_ladder	= request_var ( 'move_from_ladder', 0 );
		if ( $move_ladder != 0 )
		{
			// They are moving. Stats too?
			$move_stats	= request_var ( 'move_stats', 0 );
			if ( $move_stats != 0 )
			{
				// Yes, move the stats.
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_ladder = $move_ladder WHERE clan_ladder = $move_from_ladder AND clan_id = " . $clan_id;
				$db->sql_query ( $sql );
			}
			else
			{
				// No, delete the stats.
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_ladder = $move_ladder, clan_wins = 0, clan_losses = 0, clan_score = 1200, clan_lastscore = 0, clan_streak = 0 WHERE clan_ladder = $move_from_ladder AND clan_id = " . $clan_id;
				$db->sql_query ( $sql );
			}

			// Completed. Let the user know.
			trigger_error ( 'CLAN_MOVED' );
		}

		// Check if a match was editted.
		$match_id	= request_var ( 'match_id', 0 );
		if ( $match_id != 0 )
		{
			// A match was editted. Get the match's details.
			$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );
			$db->sql_fetchrow ( $result );

			$match_delete	= request_var ( 'match_delete', 0 );
			$match_ladder	= request_var ( 'match_ladder', 0 );

			if ( $match_delete == 1 )
			{
				// See who lost and who won to resync their stats.
				$winner	= $row[ 'match_winner' ];
				$loser	= ( $winner == $row[ 'match_challenger' ] ) ? $row[ 'match_challengee' ] : $row[ 'match_challenger' ];

				// Remove the match.
				$sql	= "DELETE FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
				$result	= $db->sql_query ( $sql );

				// Now, sync the stats for both clans.
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_wins = clan_wins - 1 WHERE clan_id = $winner AND clan_ladder = " . $match_ladder;
				$db->sql_query ( $sql );
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_losses = clan_losses - 1 WHERE clan_id = $loser AND clan_ladder = " . $match_ladder;
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				trigger_error ( 'CLAN_UPDATED' );
			}

			// Update the match.
			$match_winner	= request_var ( 'match_winner', 0 );
			$loser	= ( $match_winner == $row[ 'match_challenger' ] ) ? $row[ 'match_challengee' ] : $row[ 'match_challenger' ];

			// Update the match.
			$sql	= "UPDATE " . MATCHES_TABLE . " SET match_winner = $match_winner WHERE match_id = " . $match_id;
			$db->sql_query ( $sql );

			// Now, sync the stats for both clans.
			$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_wins = clan_wins + 1, clan_losses = clan_losses - 1 WHERE clan_id = $winner AND clan_ladder = " . $match_ladder;
			$db->sql_query ( $sql );
			$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_losses = clan_losses + 1, clan_wins = clan_wins - 1 WHERE clan_id = $loser AND clan_ladder = " . $match_ladder;
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'CLAN_UPDATED' );
		}

		// Get and update the clan's data.
		$clan_name		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_name', '', true ) ) );
		$clan_tag		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_tag', '', true ) ) );
		$clan_contact	= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_contact', '', true ) ) );
		$clan_logo		= request_var ( 'clan_logo', '' );

		// Setup the BBcode for the clan description.
		$uid			= $bitfield = $options = '';
		$allow_bbcode	= $allow_urls = $allow_smilies = true;
		generate_text_for_storage ( $clan_contact, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies );

		$sql	= "UPDATE " . CLANS_TABLE . " SET clan_name = '$clan_name', clan_tag = '$clan_tag', clan_contact = '$clan_contact', bbcode_uid = '$uid', bbcode_bitfield = '$bitfield', bbcode_options = $options, clan_logo = '$clan_logo' WHERE clan_id = " . $clan_id;
		$db->sql_query ( $sql );

		// Get and update the clan's ladder data.
		$clan_ladder	= request_var ( 'clan_ladder', array ( 0 => 0 ) );
		$delete_ladder	= request_var ( 'delete_ladder', array ( 0 => 0 ) );
		$clan_wins		= request_var ( 'clan_wins', array ( 0 => 0 ) );
		$clan_losses	= request_var ( 'clan_losses', array ( 0 => 0 ) );
		$clan_score		= request_var ( 'clan_score', array ( 0 => 0 ) );
		$clan_streak	= request_var ( 'clan_streak', array ( 0 => 0 ) );

		$i	= 0;
		foreach ( $clan_ladder AS $value )
		{
			if ( $delete_ladder[ $i ] == 1 )
			{
				// Remove the clan from this ladder.
				$sql	= "DELETE FROM " . CLANDATA_TABLE . " WHERE clan_ladder = $value AND clan_id = " . $clan_id;
				$db->sql_query ( $sql );
			}
			else
			{
				// Update the clan's ladder data.
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_wins = {$clan_wins[ $i ]}, clan_losses = {$clan_losses[ $i ]}, clan_score = {$clan_score[ $i ]}, clan_streak = {$clan_streak[ $i ]} WHERE clan_ladder = $value AND clan_id = " . $clan_id;
				$db->sql_query ( $sql );
			}

			$i++;
		}

		// Completed. Let the user know.
		trigger_error ( 'CLAN_UPDATED' );
	}
	else
	{
		// Check if a clan ID was set.
		if ( !empty ( $clan_id ) )
		{
			// Check if the clan exists.
			$clan_owner	= $clan->data ( 'clan_owner', $clan_id );
			if ( empty ( $clan_owner ) )
			{
				// The clan does not exist.
				trigger_error ( 'NONEXISTANT_CLAN' );
			}

			// Loop through the ladders the clan is joined to.
			$clan_data	= $clan->data ( '*', $clan_id );
			if ( sizeof ( $clan_data[ 'clan_ladders' ] ) > 0 )
			{
				foreach ( $clan_data[ 'clan_ladders' ] AS $value )
				{
					// Get the ladder's roots.
					$ladder_data	= $ladder->get_roots ( $value );

					// Get the clan's data for this ladder.
					$sql	= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_id = $clan_id AND clan_ladder = " . $value;
					$result	= $db->sql_query ( $sql );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					// Assign each ladder to the template.
					$template->assign_block_vars ( 'block_ladders', array (
						'LADDER_ID' => $value,
						'PLATFORM' => $ladder_data[ 'PLATFORM_NAME' ],
						'LADDER' => $ladder_data[ 'LADDER_NAME' ],
						'SUBLADDER' => $ladder_data[ 'SUBLADDER_NAME' ],
						'CLAN_WINS' => $row[ 'clan_wins' ],
						'CLAN_LOSSES' => $row[ 'clan_losses' ],
						'CLAN_SCORE' => $row[ 'clan_score' ],
						'CLAN_STREAK' => $row[ 'clan_streak' ] )
					);
				}
			}

			// Get the clan's matches.
			$sql	= "SELECT m.*, l.ladder_id FROM " . MATCHES_TABLE . " m, " . LADDERS_TABLE . " l WHERE (m.match_challenger = $clan_id OR m.match_challengee = $clan_id) AND m.match_finishtime <> '' AND m.match_ladder = l.ladder_id ORDER BY m.match_id DESC";
			$result	= $db->sql_query ( $sql );

			$i	= 0;
			while ( $row = $db->sql_fetchrow ( $result ) )
			{
				// Get the ladder's roots.
				$ladder_data	= $ladder->get_roots ( $row[ 'match_ladder' ] );

				// Assign each match to the template.
				$template->assign_block_vars ( 'block_matches', array (
					'U_ACTION' => $u_action,
					'PLATFORM' => $ladder_data[ 'PLATFORM_NAME' ],
					'LADDER' => $ladder_data[ 'LADDER_NAME' ],
					'SUBLADDER' => $ladder_data[ 'SUBLADDER_NAME' ],
					'MATCH_ID' => $row[ 'match_id' ],
					'LADDER_ID' => $row[ 'match_ladder' ],
					'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2',
					'DATE' => $user->format_date ( $row[ 'match_finishtime' ] ),
					'CHALLENGER' => $clan->data ( 'clan_name', $row[ 'match_challenger' ] ),
					'CHALLENGER_SELECTED' => ( $row[ 'match_winner' ] == $row[ 'match_challenger' ] ) ? 'selected="selected"' : '',
					'CHALLENGEE' => $clan->data ( 'clan_name', $row[ 'match_challengee' ] ),
					'CHALLENGEE_SELECTED' => ( $row[ 'match_winner' ] == $row[ 'match_challengee' ] ) ? 'selected="selected"' : '',
					'CHALLENGER_ID' => $row[ 'match_challenger' ],
					'CHALLENGEE_ID' => $row[ 'match_challengee' ],
					'WINNER' => ( $row[ 'match_finishtime' ] > 0 ) ? $clan->data ( 'clan_name', $row[ 'match_winner' ] ) : '-',
					'WINNER_ID' => $clan->data ( 'clan_id', $row[ 'match_winner' ] ) )
				);
			
				$i++;
			}

			$db->sql_freeresult ( $result );

			// Loop through the clan's ladder list.
			if ( sizeof ( $clan_data[ 'clan_ladders' ] ) > 0 )
			{
				foreach ( $clan_data[ 'clan_ladders' ] AS $value )
				{
					// Get the ladder's roots.
					$ladder_data	= $ladder->get_roots ( $value );

					// Get the clan's data for this ladder.
					$sql	= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_id = $clan_id AND clan_ladder = " . $value;
					$result	= $db->sql_query ( $sql );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					// Assign each ladder to the template.
					$template->assign_block_vars ( 'block_ladders2', array (
						'LADDER_ID' => $value,
						'PLATFORM' => $ladder_data[ 'PLATFORM_NAME' ],
						'LADDER' => $ladder_data[ 'LADDER_NAME' ],
						'SUBLADDER' => $ladder_data[ 'SUBLADDER_NAME' ] )
					);
				}
			}

			// Loop through the ladders.
			$sql	= "SELECT l.*, p.* FROM " . LADDERS_TABLE . " l, " . PLATFORMS_TABLE . " p WHERE l.ladder_platform = p.platform_id";
			$result	= $db->sql_query ( $sql );

			while ( $row = $db->sql_fetchrow ( $result ) )
			{
				// Assign it to the template.
				$template->assign_block_vars ( 'block_ladders3', array (
					'LADDER_NAME' => $row[ 'ladder_name' ],
					'PLATFORM' => $row[ 'platform_name' ] )
				);

				$sql_2		= "SELECT * FROM " . LADDERS_TABLE . " WHERE ladder_parent = " . $row[ 'ladder_id' ];
				$result_2	= $db->sql_query ( $sql_2 );

				// Loop through the ladder's sub-ladders.
				while ( $row_2 = $db->sql_fetchrow ( $result_2 ) )
				{
					// Assign them to the template.
					$template->assign_block_vars ( 'block_ladders3.block_subladders3', array (
						'LADDER_ID' => $row_2[ 'ladder_id' ],
						'LADDER_NAME' => $row_2[ 'ladder_name' ] )
					);
				}

				$db->sql_freeresult ( $result_2 );
			}

			// Get the tournaments.
			$sql	= "SELECT * FROM " . TOURNAMENTS_TABLE . " WHERE tournament_status <> 3 ORDER BY tournament_time DESC";
			$result	= $db->sql_query ( $sql );

			while ( $row = $db->sql_fetchrow ( $result ) )
			{
				// Assign the tournaments to the template.
				$template->assign_block_vars ( 'block_tournaments', array (
					'TOURNAMENT_ID' => $row[ 'tournament_id' ],
					'TOURNAMENT_NAME' => $row[ 'tournament_name' ] )
				);
			}

			$db->sql_freeresult ( $result );

			// Assign the clan's details to the template.
			decode_message ( $clan_data[ 'clan_contact' ], $clan_data[ 'bbcode_uid' ] );

			$template->assign_vars ( array (
				'CLAN_OWNER' => $clan_data[ 'clan_owner' ],
				'CLAN_ID' => $clan_id,
				'CLAN_CONTACT' => $clan_data[ 'clan_contact' ],
				'CLAN_NAME' => $clan_data[ 'clan_name' ],
				'CLAN_TAG' => $clan_data[ 'clan_tag' ] )
			);
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array ( 'U_ACTION' => $u_action ) );
	}
}

?>
