<?php
##############################################################
# FILENAME  : acp_rivals_manage_seasons.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Manage Seasons
 * Called from acp_rivals with mode == 'manage_seasons'
 */
function acp_rivals_manage_seasons ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpbb_admin_path, $phpEx;

	$ladder	= new ladder ( );

	// Are we submitting a form?
	$submit	= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form. End the season...
		$ladder_id	= request_var ( 'ladder_id', 0 );
		$season_id	= request_var ( 'season_id', 0 );

		// Get all the clans for this season's ladders.
		$sql	= "SELECT s.*, cd.* FROM " . SEASONS_TABLE . " s, " . CLANDATA_TABLE . " cd WHERE s.season_ladder = cd.clan_ladder AND s.season_status = 1 AND s.season_id = " . $season_id;
		$result	= $db->sql_query ( $sql );
		$row	= $db->sql_fetchrow ( $result );
		$db->sql_freeresult ( $result );

		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			// Basically we're going to push the clan's current data to a season.
			$sql_array	= array (
				'season_id' => $row[ 'season_id' ],
				'clan_id' => $row[ 'clan_id' ],
				'clan_wins' => $row[ 'clan_wins' ],
				'clan_losses' => $row[ 'clan_losses' ],
				'clan_score' => $row[ 'clan_score' ],
				'clan_streak' => $row[ 'clan_streak' ],
				'clan_current_rank' => $row[ 'clan_current_rank' ],
				'clan_last_rank' => $row[ 'clan_last_rank' ],
				'clan_worst_rank' => $row[ 'clan_worst_rank' ],
				'clan_best_rank' => $row[ 'clan_best_rank' ],
				'clan_ladder' => $row[ 'clan_ladder' ]
			);
			$sql		= "INSERT INTO " . SEASONDATA_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
			$db->sql_query ( $sql );
		}

		$db->sql_freeresult ( $result );

		// Reset everything for every clan!
		$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_wins = 0, clan_losses = 0, clan_score = 1200, clan_lastscore = 0, clan_streak = 0, clan_current_rank = 0, clan_last_rank = 0, clan_worst_rank = 0, clan_best_rank = 0 WHERE clan_ladder = " .  $ladder_id;
		$db->sql_query ( $sql );

		// Now, set their ranks!
		$sql	= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_ladder = " . $ladder_id;
		$result	= $db->sql_query ( $sql );

		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			$sql_2		= "SELECT MAX(clan_current_rank) AS max_rank FROM " . CLANDATA_TABLE . " WHERE clan_ladder = " . $ladder_id;
			$result_2	= $db->sql_query ( $sql_2 );
			$row_2		= $db->sql_fetchrow ( $result_2 );
			$db->sql_freeresult ( $result_2 );

			// Update their ranks.
			$new_rank	= $row_2[ 'max_rank' ] + 1;
			$sql_3		= "UPDATE " . CLANDATA_TABLE . " SET clan_current_rank = $new_rank, clan_last_rank = 0, clan_best_rank = $new_rank, clan_worst_rank = 0 WHERE clan_id = {$row[ 'clan_id' ]} AND clan_ladder = " . $ladder_id;
			$db->sql_query ( $sql_3 );
		}

		// Finally, change the seasons' status to ended.
		$sql	= "UPDATE " . SEASONS_TABLE . " SET season_status = 0 WHERE season_id = " . $season_id;
		$db->sql_query ( $sql );

		// Completed. Let the user know.
		trigger_error ( 'SEASON_ENDED' );
	}
	else
	{
		// Get the parent ladders and order them.
		$sql	= "SELECT * FROM " . LADDERS_TABLE . " WHERE ladder_parent = 0 ORDER BY ladder_order ASC";
		$result	= $db->sql_query ( $sql );

		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			// Get the platform this ladder is joined to.
			$sql_2		= "SELECT * FROM " . PLATFORMS_TABLE . " WHERE platform_id = " . $row[ 'ladder_platform' ];
			$result_2	= $db->sql_query ( $sql_2 );
			$row_2		= $db->sql_fetchrow ( $result_2 );
			$db->sql_freeresult ( $result_2 );

			// Assign each ladder to the template.
			$template->assign_block_vars ( 'block_ladders', array (
				'LADDER_NAME' => $row[ 'ladder_name' ],
				'PLATFORM_NAME' => $row_2[ 'platform_name' ] )
			);

			// Get the sub-ladders for this ladder.
			$sql_3		= "SELECT * FROM " . LADDERS_TABLE . " WHERE ladder_parent = {$row[ 'ladder_id' ]} ORDER BY subladder_order ASC";
			$result_3	= $db->sql_query ( $sql_3 );

			while ( $row_3 = $db->sql_fetchrow ( $result_3 ) )
			{
				// See if we can end or start a season...
				$sql_4		= "SELECT * FROM " . SEASONS_TABLE . " WHERE season_ladder = {$row_3[ 'ladder_id' ]} AND season_status = 1";
				$result_4	= $db->sql_query ( $sql_4 );
				$row_4		= $db->sql_fetchrow ( $result_4 );
				$db->sql_freeresult ( $result_4 );

				if ( !empty ( $row_4 ) )
				{
					// There is an on-going season, allow for ending.
					$language	= $user->lang[ 'END_SEASON' ];
					$action		= $u_action . '&amp;submit=1&amp;ladder_id=' . $row_3[ 'ladder_id' ];

					$action_2	= append_sid ( "{$phpbb_admin_path}index.$phpEx", 'i=rivals&amp;mode=edit_season&amp;season_id=' . $row_4[ 'season_id' ] );
				}
				else
				{
					// There is no season started, allow for starting.
					$language	= $user->lang[ 'START_SEASON' ];
					$action		= append_sid ( "{$phpbb_admin_path}index.$phpEx", 'i=rivals&amp;mode=add_season&amp;ladder_id=' . $row_3[ 'ladder_id' ] );

					$action_2	= '';
				}

				// Assign each sub-ladder to the template.
				$template->assign_block_vars ( 'block_ladders.block_subladders', array (
					'U_ACTION' => $action,
					'U_ACTION2' => $action_2,
					'L_LANGUAGE' => $language,
					'LADDER_NAME' => $row_3[ 'ladder_name' ] )
				);
			}

			$db->sql_freeresult ( $result_3 );
		}

		$db->sql_freeresult ( $result );
	}
}

?>
