<?php
##############################################################
# FILENAME  : ucp_rivals_clan_members.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

define ( 'DELETE_MEMBER', 1 );
define ( 'ASSIGN_MEMBER', 2 );
define ( 'ASSIGN_BACKUP', 3 );

/**
 * Manage Members
 * Called from ucp_rivals with mode == 'clan_members'
 */
function ucp_rivals_clan_members ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpEx;

	$clan	= new clan ( );

	// Are we submitting a form?
	$submit	= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		$member_id	= request_var ( 'member_id', array ( 0 => 0 ) );
		$members	= request_var ( 'members', array ( 0 => 0 ) );

		foreach ( $member_id AS $key => $value )
		{
			if ( $members[ $key ] == DELETE_MEMBER )
			{
				// Remove the member.
				$sql	= "DELETE FROM " . CLANMEMBERS_TABLE . " WHERE member_userid = $value AND member_clan = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Check to see if the member is a co-leader.
				if ( $clan->data[ 'clan_ownerb' ] == $value )
				{
					// Yes. Remove them.
					$sql	= "UPDATE " . CLANS_TABLE . " SET clan_ownerb = 0 WHERE clan_id = " . $clan->data[ 'clan_id' ];
					$db->sql_query ( $sql );
				}

				// Completed. Let the user know.
				trigger_error ( 'MEMBER_REMOVED' );
			}
			else if ( $members[ $key ] == ASSIGN_MEMBER )
			{
				/* Assign as Leader, then add the current clan owner to the clan members.
				After this, remove the selected member out of the clan members and
				assign the selected member as the new clan owner. */
				$sql_array	= array (
					'member_userid' => $clan->data[ 'clan_owner' ],
					'member_clan' => $clan->data[ 'clan_id' ],
					'member_status' => 1
				);
				$sql		= "INSERT INTO " . CLANMEMBERS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
				$db->sql_query ( $sql );

				// Delete the new leader from the members.
				$sql	= "DELETE FROM " . CLANMEMBERS_TABLE . " WHERE member_userid = $value AND member_clan = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Run the query to do the changes to the clan.
				$sql	= "UPDATE " . CLANS_TABLE . " SET clan_owner = $value WHERE clan_id = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Remove the session so the previous clan owner can not "hack" in.
				$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = 0 WHERE user_id = " . $user->data[ 'user_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				trigger_error ( 'MEMBER_ASSIGNED_AS_LEADER' );
			}
			else if ( $members[ $key ] == ASSIGN_BACKUP )
			{
				// Assign a member as a backup clan owner.
				$sql	= "UPDATE " . CLANS_TABLE . " SET clan_ownerb = $value WHERE clan_id = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				// Completed. Let the user know.
				trigger_error ( 'MEMBER_ASSIGNED_AS_BACKUP' );
			}
			else
			{
				continue;
			}
		}
	}
	else
	{
		// Get members of the clan.
		$sql	= "SELECT * FROM " . CLANMEMBERS_TABLE . " c, " . USERS_TABLE . " u WHERE c.member_clan = {$clan->data[ 'clan_id' ]} AND c.member_status = 1 AND c.member_userid = u.user_id";
		$result	= $db->sql_query ( $sql );

		$i	= 0;
		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			// Assign each member to the template.
			$template->assign_block_vars ( 'block_members', array (
				'U_PROFILE' => append_sid ( "{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&amp;u=' . $row[ 'member_userid' ] ),
				'MEMBER_ID' => $row[ 'member_userid' ],
				'MEMBER_NAME' => $row[ 'username' ],
				'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
				'ROW_OLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
			);

			$i++;
		}

		$db->sql_freeresult ( $result );

		// Assign the other variables to the template.
		$template->assign_vars ( array (
			'U_ACTION' => $u_action,
			'U_INVITE_MEMBERS' => append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=invite_members' ),
			'U_PENDING_MEMBERS' => append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=pending_members' ) ) );
	}
}

?>
