<?php
##############################################################
# FILENAME  : ucp_rivals_edit_clan.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Edit Clan
 * Called from ucp_rivals with mode == 'edit_clan'
 */
function ucp_rivals_edit_clan ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpEx;

	$clan	= new clan ( );
	$ladder	= new ladder ( );

	// Are we submitting a form?
	$submit	= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		$clan_delete	= request_var ( 'clan_delete', 0 );
		if ( $clan_delete != 0 )
		{
			// Delete the clan.
			$sql	= "DELETE FROM " . CLANS_TABLE . " WHERE clan_id = " . $clan->data[ 'clan_id' ];
			$db->sql_query ( $sql );

			// Delete the clan's data.
			$sql	= "DELETE FROM " . CLANDATA_TABLE . " WHERE clan_id = " . $clan->data[ 'clan_id' ];
			$db->sql_query ( $sql );

			// Delete all the members too.
			$sql	= "DELETE FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = " . $clan->data[ 'clan_id' ];
			$db->sql_query ( $sql );

			// Try to set the user's clan session to another clan they own.
			$sql	= "SELECT * FROM " . CLANS_TABLE . " WHERE (clan_owner = {$user->data[ 'user_id' ]} OR clan_ownerb = {$user->data[ 'user_id' ]})";
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );
			$db->sql_freeresult ( $result );

			if ( !empty ( $row[ 'clan_id' ] ) )
			{
				$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = {$row[ 'clan_id' ]} WHERE user_id = " . $clan->data[ 'clan_owner' ];
				$db->sql_query ( $sql );
			}
			else
			{
				$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = 0 WHERE user_id = " . $clan->data[ 'clan_owner' ];
				$db->sql_query ( $sql );
			}

			// Completed. Let the user know.
			trigger_error ( $user->lang[ 'rivals_cu' ] );
		}

		$clan_name		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_name', '', true ) ) );
		$clan_tag		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_tag', '', true ) ) );
		$clan_contact	= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_contact', '', true ) ) );
		$clan_logo		= $db->sql_escape ( request_var ( 'clan_logo', '' ) );

		// Setup the BBcode for the clan description.
		$uid			= $bitfield = $options = '';
		$allow_bbcode	= $allow_urls = $allow_smilies = true;
		generate_text_for_storage ( $clan_contact, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies );

		// Edit the clan.
		$sql	= "UPDATE " . CLANS_TABLE . " SET clan_name = '$clan_name', clan_tag = '$clan_tag', clan_contact = '$clan_contact', clan_logo = '$clan_logo', bbcode_uid = '$uid', bbcode_bitfield = '$bitfield', bbcode_options = $options WHERE clan_id = " . $clan->data[ 'clan_id' ];
		$db->sql_query ( $sql );

		// Completed. Let the user know.
		trigger_error ( $user->lang[ 'rivals_cu' ] );
	}
	else
	{
		// Assign the other variables to the template.
		decode_message ( $clan->data[ 'clan_contact' ], $clan->data[ 'bbcode_uid' ] );
		$template->assign_vars ( array (
			'U_ACTION' => $u_action,
			'CLAN_CONTACT' => $clan->data[ 'clan_contact' ],
			'CLAN_NAME' => $clan->data[ 'clan_name' ],
			'CLAN_TAG' => $clan->data[ 'clan_tag' ],
			'CLAN_LOGO' => $clan->data[ 'clan_logo' ] )
		);
	}
}

?>
