<?php
##############################################################
# FILENAME  : ucp_rivals_matches.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

define ( 'REPORT_WIN', 1 );
define ( 'CONFIRM_WIN', 2 );
define ( 'CONTEST_RESULT', 3 );

/**
 * Manage Matches
 * Called from ucp_rivals with mode == 'matches'
 */
function ucp_rivals_matches ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpEx;

	$clan	= new clan ( );

	// Are we submitting a form?
	$submit	= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		$match_id	= request_var ( 'match_id', 0 );
		$type		= request_var ( 'type', 0 );

		switch ( $type )
		{
			case REPORT_WIN :
				// Get the match information.
				$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$db->sql_freeresult ( $result );

				// Confirm that this is their match.
				if ( !in_array ( $clan->data[ 'clan_id' ], array ( $row[ 'match_challenger' ], $row[ 'match_challengee' ] ) ) )
				{
					trigger_error ( );
				}

				$opponent	= ( $row[ 'match_challenger' ] == $clan->data[ 'clan_id' ] ) ? $row[ 'match_challengee' ] : $row[ 'match_challenger' ];
				$opponent	= $clan->data ( 'clan_owner', $opponent );

				// Set the match winner.
				$sql	= "UPDATE " . MATCHES_TABLE . " SET match_winner = {$clan->data[ 'clan_id' ]} WHERE match_id = " . $match_id;
				$db->sql_query ( $sql );

				// Send a PM to the looser to tell them to confirm the win...
				$subject	= $user->lang[ 'PMCONFIRMWIN' ];
				$message	= sprintf ( $user->lang[ 'PMCONFIRMWINTXT' ], $clan->data[ 'clan_name' ] );
				insert_pm ( $opponent, $user->data, $subject, $message );

				// Completed. Let the user know.
				trigger_error ( 'MATCH_REPORTED' );
			break;
			case CONFIRM_WIN :
				// Get the match information.
				$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$db->sql_freeresult ( $result );

				// Confirm that this is their match.
				if ( !in_array ( $clan->data[ 'clan_id' ], array ( $row[ 'match_challenger' ], $row[ 'match_challengee' ] ) ) )
				{
					trigger_error ( );
				}

				$opponent	= ( $row[ 'match_challenger' ] == $clan->data[ 'clan_id' ] ) ? $row[ 'match_challengee' ] : $row[ 'match_challenger' ];
				$opponent	= $clan->data ( 'clan_owner', $opponent );

				// Set the match looser.
				$sql	= "UPDATE " . MATCHES_TABLE . " SET match_looser = {$clan->data[ 'clan_id' ]}, match_finishtime = " . time ( ) . " WHERE match_id = " . $match_id;
				$db->sql_query ( $sql );

				// Get the match information (repopulate).
				$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$db->sql_freeresult ( $result );

				// Get both clan's data.
				$sql_2		= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_id = {$row[ 'match_winner' ]} AND clan_ladder = " . $row[ 'match_ladder' ];
				$result_2	= $db->sql_query ( $sql_2 );
				$row_2		= $db->sql_fetchrow ( $result_2 );
				$db->sql_freeresult ( $result_2 );

				$sql_3		= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_id = {$row[ 'match_looser' ]} AND clan_ladder = " . $row[ 'match_ladder' ];
				$result_3	= $db->sql_query ( $sql_3 );
				$row_3		= $db->sql_fetchrow ( $result_3 );
				$db->sql_freeresult ( $result_3 );

				// Calculate the new clan stats for the winning clan.
				// ELO scoring system.
				$score	= calculate_elo ( $row_2[ 'clan_score' ], $row_3[ 'clan_score' ], true );
				$streak	= ( $clan->data ( 'clan_streak', $row[ 'match_winner' ], $row[ 'match_ladder' ] ) < 0 ) ? 'clan_streak = 0' : 'clan_streak = clan_streak + 1';
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_wins = clan_wins + 1, clan_lastscore = clan_score, clan_score = $score, $streak WHERE clan_id = {$row[ 'match_winner' ]} AND clan_ladder = " . $row[ 'match_ladder' ];
				$db->sql_query ( $sql );

				// Calculate the new clan stats for the loosing clan.
				// ELO scoring system.
				$score	= calculate_elo ( $row_3[ 'clan_score' ], $row_2[ 'clan_score' ], false );
				$streak	= ( $clan->data ( 'clan_streak', $row[ 'match_looser' ], $row[ 'match_ladder' ] ) <= 0 ) ? 'clan_streak = clan_streak - 1' : 'clan_streak = 0';
				$sql	= "UPDATE " . CLANDATA_TABLE . " SET clan_losses = clan_losses + 1, clan_lastscore = clan_score, clan_score = $score, $streak WHERE clan_id = {$row[ 'match_looser' ]} AND clan_ladder = " . $row[ 'match_ladder' ];
				$db->sql_query ( $sql );

				// Get the match information (repopulate).
				$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE match_id = " . $match_id;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );
				$db->sql_freeresult ( $result );

				// Now, update the ranks. Swap if needed.
				$ladder	= new ladder ( );
				$ladder->update_ranks ( $row[ 'match_winner' ], $row[ 'match_looser' ], $row[ 'match_ladder' ] );

				// Send a PM to the winner to tell them that it was confirmed
				$subject	= $user->lang[ 'PMWINCONFIRMED' ];
				$message	= sprintf ( $user->lang[ 'PMWINCONFIRMED' ], $clan->data[ 'clan_name' ] );
				insert_pm ( $opponent, $user->data, $subject, $message );

				// Completed. Let the user know.
				trigger_error ( 'MATCH_REPORTED' );
			break;
			case CONTEST_RESULT :
				$redirect	= append_sid ( "{$phpbb_admin_path}ucp.$phpEx", 'i=rivals&amp;mode=ticket' );
				redirect ( $redirect );
			break;
		}
	}
	else
	{
		// Check if the clan is apart of a ladder yet.
		if ( empty ( $clan->data[ 'clan_ladders' ] ) )
		{
			// They are not apart of a ladder. Deny them.
			trigger_error ( 'CLAN_NOTIN_LADDER' );
		}

		// Get all the unreported and reported matches.
		$sql	= "SELECT * FROM " . MATCHES_TABLE . " WHERE (match_challengee = {$clan->data[ 'clan_id' ]} OR match_challenger = {$clan->data[ 'clan_id' ]})";
		$result	= $db->sql_query ( $sql );

		while ( $row = $db->sql_fetchrow ( $result ) )
		{
			$opponent	= ( $row[ 'match_challenger' ] == $clan->data[ 'clan_id' ] ) ? $row[ 'match_challengee' ] : $row[ 'match_challenger' ];

			if ( empty ( $row[ 'match_winner' ] ) )
			{
				if ( $row[ 'match_finishtime' ] == 0 )
				{
					// Assign each reported match to the template.
					$template->assign_block_vars ( 'block_unreported', array (
						'U_OPPONENT' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_profile&amp;clan_id=' . $opponent ),
						'U_REPORT_WIN'	=> $u_action . '&amp;match_id=' . $row[ 'match_id' ] . '&amp;type=' . REPORT_WIN . '&amp;submit=1',
						'OPPONENT' => ( $row[ 'match_challenger' ] == $clan->data[ 'clan_id' ] ) ? $clan->data ( 'clan_name', $row[ 'match_challengee' ] ) : $clan->data ( 'clan_name', $row[ 'match_challenger' ] ),
						'TIME' => $user->format_date ( $row[ 'match_posttime' ] ),
						'MATCH_ID' => $row[ 'match_id' ],
						'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
						'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
					);
				}
			}
			else
			{
				if ( $row[ 'match_winner' ] != $clan->data[ 'clan_id' ] && empty ( $row[ 'match_looser' ] ) )
				{
					// Assign each unreported match to the template.
					$template->assign_block_vars ( 'block_reported', array (
						'U_OPPONENT' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_profile&amp;clan_id=' . $opponent ),
						'U_CONFIRM_WIN'	=> $u_action . '&amp;match_id=' . $row[ 'match_id' ] . '&amp;type=' . CONFIRM_WIN . '&amp;submit=1',
						'U_CONTEST_RESULT'	=> $u_action . '&amp;match_id=' . $row[ 'match_id' ] . '&amp;type=' . CONTEST_RESULT . '&amp;submit=1',
						'OPPONENT' => ( $row[ 'match_challenger' ] == $clan->data[ 'clan_id' ] ) ? $clan->data ( 'clan_name', $row[ 'match_challengee' ] ) : $clan->data ( 'clan_name', $row[ 'match_challenger' ] ),
						'TIME' => $user->format_date ( $row[ 'match_posttime' ] ),
						'MATCH_ID' => $row[ 'match_id' ],
						'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
						'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
					);
				}
			}

			$i++;
		}

		$db->sql_freeresult ( $result );

		// Assign the other variables to the template.
		$template->assign_vars ( array ( 'U_ACTION' => $u_action ) );
	}
}

?>
