<?php
##############################################################
# FILENAME  : ucp_rivals_ticket.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Issue a Ticket
 * Called from ucp_rivals with mode == 'ticket'
 */
function ucp_rivals_ticket ( $id, $mode, $u_action )
{
	global	$config, $db, $user, $template;
	global	$phpbb_root_path, $phpEx;

	$clan	= new clan ( );
	$ladder	= new ladder ( );

	// Are we submitting a form?
	$submit	= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form.
		$attachment	= $_FILES[ 'attachment' ];
		$type		= $db->sql_escape ( request_var ( 'type', '' ) );
		$ticket		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'ticket', '', true ) ) );

		if ( !empty ( $attachment[ 'name' ] ) )
		{
			// Get the file's info for reference and checking.
			include ( $phpbb_root_path . 'includes/functions_upload.' . $phpEx );
			$upload = new fileupload ( 'RIVALS_' );
			
			$upload->set_allowed_extensions ( array ( 'jpg', 'jpeg', 'png', 'tiff', 'pdf', 'gif', 'swf', 'mpeg', 'mpg', 'wmv', 'wav', 'avi', 'bmp' ) );
			
			$file = $upload->form_upload ( 'attachment' );
			$file->clean_filename ( 'unique_ext' );
			$file->move_file ( 'uploads/', false, false, CHMOD_READ );

			// Check if it was uploaded.
			if ( !$file->is_uploaded ( ) )
			{
				// Did not upload. Let the user know.
				trigger_error ( 'RIVALS_FILE_NOT_UPLOADED' );
			}

			// Send a PM to the ticket receiver.
			$subject	= $user->lang[ 'PMTICKET' ] . ' (' . $type . ')';
			$message	= sprintf ( $user->lang[ 'PMTICKETTXT' ], $config[ 'server_protocol' ], $config[ 'server_name' ], $config[ 'script_path' ], $clan->data[ 'clan_id' ], $clan->data[ 'clan_name' ], $ticket, $config[ 'server_protocol' ], $config[ 'server_name' ], $config[ 'script_path' ], $file->realname );
		}
		else
		{
			// Send a PM to the ticket receiver.
			$subject	= $user->lang[ 'PMTICKET' ] . ' (' . $type . ')';
			$message	= sprintf ( $user->lang[ 'PMTICKETTXT' ], $config[ 'server_protocol' ], $config[ 'server_name' ], $config[ 'script_path' ], $clan->data[ 'clan_id' ], $clan->data[ 'clan_name' ], $ticket, '', '', '', '' );
		}

		insert_pm ( $config[ 'rivals_ticketreceiver' ], $user->data, $subject, $message );

		// Completed. Let the user know.
		trigger_error ( 'TICKET_SENT' );
	}
	else
	{
		// Check if the clan is apart of a ladder yet.
		if ( sizeof ( $clan->data[ 'clan_ladders' ] ) == 0 )
		{
			// They are not apart of a ladder. Deny them.
			trigger_error ( 'CLAN_NOTIN_LADDER' );
		}

		// Assign the other variables to the template.
		$template->assign_vars ( array ( 'U_ACTION' => $u_action ) );
	}
}

?>
