<?php
##############################################################
# FILENAME  : ucp_rivals_tournament_report_double.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Report for Double Elimination Tournament
 * Called from ucp_rivals with mode == 'tournament_report_double'
 */
function ucp_rivals_tournament_report_double ( $id, $mode, $u_action )
{
	global	$db, $user, $template;
	global	$phpbb_root_path, $phpEx;

	$clan		= new clan ( );
	$tournament	= new tournament ( );

	// Are we submitting a form?
	$tournament_id	= request_var ( 'tournament_id', 0 );
	$submit			= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form.
		$win_loss	= $db->sql_escape ( request_var ( 'win_loss', '' ) );

		// Get the clan's tournament data.
		$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_tournament = $tournament_id AND clan_id = {$clan->data[ 'clan_id' ]} ORDER BY clan_bracket DESC";
		$result	= $db->sql_query_limit ( $sql, 1 );
		$row	= $db->sql_fetchrow ( $result );
		$db->sql_freeresult ( $result );

		// Get the clan's opponent.
		$opp	= $tournament->get_matchup ( $row[ 'clan_bracket' ], $row[ 'clan_position' ] );

		// Check if a report was made by the opponent.
		$sql	= "SELECT * FROM " . TREPORTS_TABLE . " WHERE report_tournament = $tournament_id AND clan_1id = $opp AND clan_2id = 0";
		$result	= $db->sql_query ( $sql );
		$row	= $db->sql_fetchrow ( $result );
		$db->sql_freeresult ( $result );

		if ( sizeof ( $row ) > 0 )
		{
			// A report does exist.
			$sql	= "UPDATE " . TREPORTS_TABLE . " SET clan_2 = '{$clan->data[ 'clan_name' ]}', clan_r2 = '$win_loss', clan_2id = {$clan->data[ 'clan_id' ]} WHERE report_id = " . $row[ 'report_id' ];
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'TOURNAMENT_REPORTED' );
		}
		else
		{
			// A report does not exist. Create a new one.
			$sql_array	= array (
				'report_tournament' => $tournament_id,
				'clan_1' => $clan->data[ 'clan_name' ],
				'clan_2' => '',
				'clan_r1' => $win_loss,
				'clan_r2' => '',
				'report_time' => time ( ),
				'clan_1id' => $clan->data[ 'clan_id' ],
				'clan_2id' => 0
			);
			$sql		= "INSERT INTO " . TREPORTS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
			$db->sql_query ( $sql );

			// Completed. Let the user know.
			trigger_error ( 'TOURNAMENT_REPORTED' );
		}
	}
	else
	{
		// Get the tournament's details for this clan.
		$sql	= "SELECT t.* FROM " . TOURNAMENTS_TABLE . ", t " . TCLANS_TABLE . " tc WHERE t.tournament_id = $tournament_id AND tc.clan_tournament = t.tournament_id AND tc.clan_id = {$clan->data[ 'clan_id' ]} ORDER BY clan_position, clan_bracket DESC";
		$result	= $db->sql_query ( $sql );
		$row	= $db->sql_fetchrow ( $result );
		$db->sql_freeresult ( $result );

		if ( !empty ( $row[ 'clan_looser' ] ) )
		{
			// Get the clan's opponent for the current tournament and position.
			$opp	= $tournament->get_matchup ( $row[ 'clan_bracket' ], $row[ 'clan_position' ], $row[ 'clan_tournament' ], 1 );
		}
		else
		{
			// Get the clan's opponent for the current tournament and position.
			$opp	= $tournament->get_matchup ( $row[ 'clan_bracket' ], $row[ 'clan_position' ], $row[ 'clan_tournament' ] );
		}

		// Assign the data to the template.
		$template->assign_vars ( array (
			'U_ACTION' => $u_action,
			'TOURNAMENT_ID' => $row[ 'tournament_id' ],
			'L_TOURNAMENT_REPORT' => sprintf ( $user->lang[ 'TOURNAMENT_REPORT_INFO' ], $row[ 'tournament_name' ], $clan->data ( 'clan_name', $opp ), ordinal ( ( $row[ 'clan_bracket' ] > 0 ) ? $row[ 'clan_bracket' ] : $row[ 'clan_bracket' ] ) ) )
		);
	}
}

?>
