<?php
##############################################################
# FILENAME  : ucp_rivals_tournaments.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Manage Tournaments
 * Called from ucp_rivals with mode == 'tournaments'
 */
function ucp_rivals_tournaments ( $id, $mode, $u_action )
{
	global	$db, $user,$template;
	global	$phpbb_root_path, $phpEx;

	$clan		= new clan ( );
	$tournament	= new tournament ( );

	// Are we submitting a form?
	$submit		= request_var ( 'submit', '' );
	if ( !empty ( $submit ) )
	{
		// Yes, handle the form.
		$tournament_id	= request_var ( 'tournament_id', 0 );
		$quit			= request_var ( 'quit', 0 );

		// Check for a quit.
		if ( $quit == 1 )
		{
			// The clan wishes to quit the tournament.Get the tournament's details.
			$sql	= "SELECT * FROM " . TOURNAMENTS_TABLE . " WHERE tournament_id = " . $tournament_id;
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );
			$db->sql_freeresult ( $result );

			if ( $row[ 'tournament_status' ] == 1 )
			{
				// Remove the clan.
				$sql	= "DELETE FROM " . TCLANS_TABLE . " WHERE clan_tournament = $tournament_id AND clan_id = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );

				$tournaments	= unserialize ( $clan->data[ 'clan_tournaments' ] );
				for ( $i = 0; $i < sizeof ( $tournaments ); $i++ )
				{
					if ( $tournaments[ $i ] == $tournament_id )
					{
						// Remove the tournament from the array.
						unset ( $tournaments[ $i ] );
					}
				}

				// Update the clan's data.
				$tournaments	= ( sizeof ( $tournaments ) > 0 ) ? serialize ( $tournaments ) : '';
				$sql	= "UPDATE " . CLANS_TABLE . " SET clan_tournaments = '$tournaments' WHERE clan_id = " . $clan->data[ 'clan_id' ];
				$db->sql_query ( $sql );
			}

			// Compeleted. Let the user know.
			trigger_error ( 'TOURNAMENT_QUITTED' );
		}
	}
	else
	{
		// Get the clan's tournaments.
		$tournaments	= unserialize ( $clan->data[ 'clan_tournaments' ] );
		if ( !empty ( $clan->data[ 'clan_tournaments' ] ) )
		{
			// Loop through the tournaments!
			$sql	= "SELECT * FROM " . TOURNAMENTS_TABLE . " WHERE tournament_id IN(" . implode ( $tournaments ) . ")";
			$result	= $db->sql_query ( $sql );

			while ( $row = $db->sql_fetchrow ( $result ) )
			{
				if ( $row[ 'tournament_status' ] == 2 )
				{
					$tournament_finishedclans	= ( !empty ( $row[ 'tournament_finishedclans' ] ) ) ? unserialize ( $row[ 'tournament_finishedclans' ] ) : array ( );
					if ( !in_array ( $clan->data[ 'clan_id' ], $tournament_finishedclans ) )
					{
						// Get the clan's details for the tournament.
						$sql_2		= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_tournament = {$row[ 'tournament_id' ]} AND clan_id = {$clan->data[ 'clan_id' ]} ORDER BY clan_position, clan_bracket DESC";
						$result_2	= $db->sql_query_limit ( $sql_2, 1 );
						$row_2		= $db->sql_fetchrow ( $result_2 );
						$db->sql_freeresult ( $result_2 );

						// Double. Check if the clan is in the winner or looser bracket.
						$sql_3		= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_tournament = {$row[ 'tournament_id' ]} AND clan_id = {$clan->data[ 'clan_id' ]} AND clan_looser = 1 ORDER BY clan_position, clan_bracket DESC";
						$result_3	= $db->sql_query_limit ( $sql_3, 1 );
						$row_3		= $db->sql_fetchrow ( $result_3 );
						$db->sql_freeresult ( $result_3 );

						if ( !empty ( $row_3 ) )
						{
							// Get the clan's opponent for the current tournament and position.
							$opp	= $tournament->get_matchup ( $row_3[ 'clan_bracket' ], $row_3[ 'clan_position' ], $row_3[ 'clan_tournament' ], 1 );
						}
						else
						{
							// Get the clan's opponent for the current tournament and position.
							$opp	= $tournament->get_matchup ( $row_2[ 'clan_bracket' ], $row_2[ 'clan_position' ], $row_2[ 'clan_tournament' ] );
						}

						if ( $opp != false )
						{
							// Assign each tournament to the template.
							$template->assign_block_vars ( 'block_started_tournaments', array (
								'U_ACTION' => ( $row[ 'tournament_type' ] == 1 ) ? append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=tournament_report_single&amp;tournament_id=' . $row[ 'tournament_id' ] ) : append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=tournament_report_double&amp;tournament_id=' . $row[ 'tournament_id' ] ),
								'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
								'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2',
								'TOURNAMENT_ID' => $row[ 'tournament_id' ],
								'TOURNAMENT_NAME' => $row[ 'tournament_name' ] )
							);
						}
					}
				}
				else
				{
					// Assign each tournament to the template.
					$template->assign_block_vars ( 'block_notstarted_tournaments', array (
						'U_QUIT' => $u_action . '&amp;quit=1&amp;submit=1&amp;tournament_id=' . $row[ 'tournament_id' ],
						'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
						'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2',
						'TOURNAMENT_ID' => $row[ 'tournament_id' ],
						'TOURNAMENT_NAME' => $row[ 'tournament_name' ] )
					);
				}
			}

			$db->sql_freeresult ( $result );
		}
	}
}

?>
