<?php
##############################################################
# FILENAME  : ucp_rivals.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

class ucp_rivals
{
	var	$u_action;

	function main ( $id, $mode )
	{
		global	$db, $user, $template;
		global	$phpbb_root_path, $phpEx;

		// Include Rivals' classes and phpBB functions.
		include ( $phpbb_root_path . 'rivals/classes/class_clan.' . $phpEx );
		include ( $phpbb_root_path . 'rivals/classes/class_tournament.' . $phpEx );
		include ( $phpbb_root_path . 'rivals/classes/class_ladder.' . $phpEx );
		include ( $phpbb_root_path . 'rivals/functions.' . $phpEx );
		include ( $phpbb_root_path . 'includes/functions_privmsgs.' . $phpEx );

		// Setup the language.
		$user->add_lang ( 'mods/lang_rivals' );

		// Switch between the modes to manage Rivals.
		switch ( $mode )
		{
			case 'main' :
				$this->tpl_name		= 'rivals/ucp_rivals_main';
				$this->page_title	= 'UCP_RIVALS';

				$clan	= new clan ( );
				$ladder	= new ladder ( );

				// Check to see if the user has a clan.
				if ( $user->data[ 'clan_session' ] == 0 )
				{
					// They don't, redirect them to make a clan.
					$redirect	= append_sid ( "{$phpbb_admin_path}rivals.$phpEx", 'action=add_clan' );
					redirect ( $redirect );
				}

				$switch	= request_var ( 'switch', 0 );
				if ( !empty ( $switch ) )
				{
					// Quick clan switching feature. Check for hacking attempt.
					$sql	= "SELECT * FROM " . CLANS_TABLE . " WHERE (clan_owner = {$user->data[ 'user_id' ]} OR clan_ownerb = {$user->data[ 'user_id' ]}) AND clan_id = " . $switch;
					$result	= $db->sql_query ( $sql );
					$row	= $db->sql_fetchrow ( $result );
					$db->sql_freeresult ( $result );

					if ( sizeof ( $row ) == 0 )
					{
						// This clan is not theirs. Redirect them back to the Clan CP.
						redirect ( $this->u_action );
					}

					// Update the user's session.
					$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = $switch WHERE user_id = " . $user->data[ 'user_id' ];
					$db->sql_query ( $sql );

					// Completed. Redirect the user back to the Clan CP.
					redirect ( $this->u_action );
				}

				// Get a list of the user's other clans.
				$sql	= "SELECT * FROM " . CLANS_TABLE . " WHERE (clan_owner = {$user->data[ 'user_id' ]} OR clan_ownerb = {$user->data[ 'user_id' ]}) AND clan_id <> " . $clan->data[ 'clan_id' ];
				$result	= $db->sql_query ( $sql );

				$i	= 0;
				while ( $row = $db->sql_fetchrow ( $result ) )
				{
					// Assign the clans to the template.
					$template->assign_block_vars ( 'block_switch', array (
						'U_ACTION' => $this->u_action . '&amp;switch=' . $row[ 'clan_id' ],
						'CLAN_NAME' => $row[ 'clan_name' ] )
					);

					$i++;
				}

				$db->sql_freeresult ( $result );

				// Get the challenges.
				$sql		= "SELECT COUNT(challenge_id) AS the_challenges FROM " . CHALLENGES_TABLE . " WHERE challengee = " . $clan->data[ 'clan_id' ];
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );
				$challenges	= $row[ 'the_challenges' ];
				$db->sql_freeresult ( $result );

				// Get the on-going challenges.
				$sql		= "SELECT COUNT(match_id) AS the_ogmatches FROM " . MATCHES_TABLE . " WHERE match_finishtime = 0 AND (match_challenger = {$clan->data[ 'clan_id' ]} OR match_challengee = {$clan->data[ 'clan_id' ]})";
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );
				$ogmatches	= $row[ 'the_ogmatches' ];
				$db->sql_freeresult ( $result );

				$sql		= "SELECT COUNT(match_id) AS the_matches FROM " . MATCHES_TABLE . " WHERE match_finishtime > 0 AND (match_challenger = {$clan->data[ 'clan_id' ]} OR match_challengee = {$clan->data[ 'clan_id' ]})";
				$result		= $db->sql_query ( $sql );
				$row		= $db->sql_fetchrow ( $result );
				$matches	= $row[ 'the_matches' ];
				$db->sql_freeresult ( $result );

				// Check if we need to remove any challenges.
				$sql	= "SELECT * FROM " . CHALLENGES_TABLE . " WHERE challenger = " . $clan->data[ 'clan_id' ];
				$result	= $db->sql_query ( $sql );

				while ( $row = $db->sql_fetchrow ( $result ) )
				{
					// Get the time difference in days.
					$days	= intval ( floor ( ( time ( ) - $row[ 'challenge_posttime' ] ) / 86400 ) );

					if ( $days >= 1 )
					{
						// The challenge hasent been accepted within 24 hours. Delete.
						$sql	= "DELETE FROM " . CHALLENGES_TABLE . " WHERE challenge_id = " . $row[ 'challenge_id' ];
						$db->sql_query ( $sql );

						// Send a PM to the clan owner to let them know.
						$challengee	= $clan->data ( 'clan_name', $row[ 'challengee' ] );
						$subject	= $user->lang[ 'PM_CHALLENGEDELETED' ];
						$message	= sprintf ( $user->lang[ 'PM_CHALLENGEDELETEDTXT' ], $challengee, $challengee );
						insert_pm ( $clan->data[ 'clan_owner' ], $user->data, $subject, $message );
					}
				}

				$db->sql_freeresult ( $result );

				// Assign the other variables to the template.
				$template->assign_vars ( array (
					'L_WELCOMETXT' => sprintf ( $user->lang[ 'WELCOME_CCPTXT' ], $clan->data[ 'clan_name' ] ),
					'CLAN_NAME' => $clan->data[ 'clan_name' ],
					'CHALLENGES' => $challenges,
					'ONGOING_MATCHES' => $ogmatches,
					'FINISHED_MATCHES' => $matches )
				);
			break;
			case 'add_challenge' :
				$this->tpl_name		= 'rivals/ucp_rivals_add_challenge';
				$this->page_title	= 'UCP_RIVALS_ADD_CHALLENGE';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_add_challenge.' . $phpEx );
				ucp_rivals_add_challenge ( $id, $mode, $this->u_action );
			break;
			case 'challenges' :
				$this->tpl_name		= 'rivals/ucp_rivals_challenges';
				$this->page_title	= 'UCP_RIVALS_CHALLENGES';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_challenges.' . $phpEx );
				ucp_rivals_challenges ( $id, $mode, $this->u_action );
			break;
			case 'edit_clan' :
				$this->tpl_name		= 'rivals/ucp_rivals_edit_clan';
				$this->page_title	= 'UCP_RIVALS_EDIT_CLAN';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_edit_clan.' . $phpEx );
				ucp_rivals_edit_clan ( $id, $mode, $this->u_action );
			break;
			case 'find_clan' :
				$this->tpl_name		= 'rivals/ucp_rivals_find_clan';
				$this->page_title	= 'UCP_RIVALS_FIND_CLAN';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_find_clan.' . $phpEx );
				ucp_rivals_find_clan ( $id, $mode, $this->u_action );
			break;
			case 'matches' :
				$this->tpl_name		= 'rivals/ucp_rivals_matches';
				$this->page_title	= 'UCP_RIVALS_MATCHES';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_matches.' . $phpEx );
				ucp_rivals_matches ( $id, $mode, $this->u_action );
			break;
			case 'match_finder' :
				$this->tpl_name		= 'rivals/ucp_rivals_match_finder';
				$this->page_title	= 'UCP_RIVALS_MATCH_FINDER';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_match_finder.' . $phpEx );
				ucp_rivals_match_finder ( $id, $mode, $this->u_action );
			break;
			case 'clan_members' :
				$this->tpl_name		= 'rivals/ucp_rivals_clan_members';
				$this->page_title	= 'UCP_RIVALS_CLAN_MEMBERS';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_clan_members.' . $phpEx );
				ucp_rivals_clan_members ( $id, $mode, $this->u_action );
			break;
			case 'pending_members' :
				$this->tpl_name		= 'rivals/ucp_rivals_pending_members';
				$this->page_title	= 'UCP_RIVALS_PENDING_MEMBERS';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_pending_members.' . $phpEx );
				ucp_rivals_pending_members ( $id, $mode, $this->u_action );
			break;
			case 'invite_members' :
				$this->tpl_name		= 'rivals/ucp_rivals_invite_members';
				$this->page_title	= 'UCP_RIVALS_INVITE_MEMBERS';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_invite_members.' . $phpEx );
				ucp_rivals_invite_members ( $id, $mode, $this->u_action );
			break;
			case 'ticket' :
				$this->tpl_name		= 'rivals/ucp_rivals_ticket';
				$this->page_title	= 'UCP_RIVALS_TICKET';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_ticket.' . $phpEx );
				ucp_rivals_ticket ( $id, $mode, $this->u_action );
			break;
			case 'tournaments' :
				$this->tpl_name		= 'rivals/ucp_rivals_tournaments';
				$this->page_title	= 'UCP_RIVALS_TOURNAMENTS';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_tournaments.' . $phpEx );
				ucp_rivals_tournaments ( $id, $mode, $this->u_action );
			break;
			case 'tournament_report_single' :
				$this->tpl_name		= 'rivals/ucp_rivals_tournament_report';
				$this->page_title	= 'UCP_RIVALS_TOURNAMENTS_REPORT_SINGLE';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_tournament_report_single.' . $phpEx );
				ucp_rivals_tournament_report_single ( $id, $mode, $this->u_action );
			break;
			case 'tournament_report_double' :
				$this->tpl_name		= 'rivals/ucp_rivals_tournament_report';
				$this->page_title	= 'UCP_RIVALS_TOURNAMENTS_REPORT_DOUBLE';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_tournament_report_double.' . $phpEx );
				ucp_rivals_tournament_report_double ( $id, $mode, $this->u_action );
			break;
			case 'matchcomm' :
				$this->tpl_name		= 'rivals/ucp_rivals_matchcomm';
				$this->page_title	= 'UCP_RIVALS_MATCHCOMM';

				// Include the file for this mode.
				include ( $phpbb_root_path . 'includes/ucp/rivals/ucp_rivals_matchcomm.' . $phpEx );
				ucp_rivals_matchcomm ( $id, $mode, $this->u_action );
			break;
		}
	}
}

?>
