<?php
##############################################################
# FILENAME  : install.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
define ( 'IN_PHPBB', true );
$phpbb_root_path	= '../';
$phpEx				= substr ( strrchr ( __FILE__, '.' ), 1 );
include ( $phpbb_root_path . 'common.' . $phpEx );
include ( $phpbb_root_path . 'install_rivals/functions_install.' . $phpEx );
include ( $phpbb_root_path . 'includes/db/db_tools.' . $phpEx );

// Initilize the phpBB sessions.
$user->session_begin ( );
$auth->acl ( $user->data );
$user->setup ( 'mods/lang_rivals' );

// Check to make sure the user is a founder of the board.
if ( $user->data[ 'user_type' ] != USER_FOUNDER )
{
	// They are not. Let the user know.
	trigger_error ( 'INSTALLER_FOUNDER' );
}

$submit	= request_var ( 'submit', '' );
if ( !empty ( $submit ) )
{
	// Check to see if we are installing or upgrading.
	if ( confirm_box ( true ) )
	{
		// We are installing. Install the modules and their categories.
		$error	= array ( );
		install_module ( 'acp', 'acp_rivals', $error, 'ACP_CAT_RIVALS' );
		install_module ( 'ucp', 'ucp_rivals', $error, 'UCP_CAT_RIVALS' );
		if ( !empty ( $error ) )
		{
			// Module(s) have failed. Let the user know.
			trigger_error ( 'INSTALLER_MF' );
		}
		
		// Install the database tables and data.
		load_schema ( $phpbb_root_path . 'install_rivals/schemas/' );
		$db_tools	= new phpbb_db_tools ( $db );
		$db_tools->sql_column_add ( USERS_TABLE, 'clan_session', array ( 'UINT', 0 ) );
		
		// Purge the board, styles and permissions caches.
		set_config ( 'rivals_ticketreceiver', 2 );
		set_config ( 'rivals_byeclan', 0 );
		phpbb_cleanup ( );
	}
	else
	{
		// We are upgrading.
		set_config ( 'rivals_byeclan', 0 );

		phpbb_cleanup ( );
		trigger_error ( 'UPGRADE_COMPLETE' );
	}

	// Completed. Let the user know.
	trigger_error ( 'INSTALLER_COMPLETE' );
}
else
{
	// Show the confirmation box to see if we will install or upgrade Rivals.
	$hidden_fields	= build_hidden_fields ( array ( 'submit' => true ) );
	confirm_box ( false, $user->lang[ 'INSTALL_OR_UPGRADE' ], $hidden_fields );
}

?>
