/*

 $Id: $

*/

BEGIN TRANSACTION
GO

/*
	Table: 'phpbb_rivals_challenges'
*/
CREATE TABLE [phpbb_rivals_challenges] (
	[challenge_id] [int] IDENTITY (1, 1) NOT NULL ,
	[challenge_ladder] [int] DEFAULT (0) NOT NULL ,
	[challenger] [int] DEFAULT (0) NOT NULL ,
	[challengee] [int] DEFAULT (0) NOT NULL ,
	[challenge_posttime] [int] DEFAULT (0) NOT NULL ,
	[challenge_details] [varchar] (4000) DEFAULT ('') NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_challenges] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_challenges] PRIMARY KEY  CLUSTERED 
	(
		[challenge_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_clanmembers'
*/
CREATE TABLE [phpbb_rivals_clanmembers] (
	[member_id] [int] IDENTITY (1, 1) NOT NULL ,
	[member_clan] [int] DEFAULT (0) NOT NULL ,
	[member_userid] [int] DEFAULT (0) NOT NULL ,
	[member_status] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_clanmembers] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_clanmembers] PRIMARY KEY  CLUSTERED 
	(
		[member_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_clans'
*/
CREATE TABLE [phpbb_rivals_clans] (
	[clan_id] [int] IDENTITY (1, 1) NOT NULL ,
	[clan_name] [varchar] (255) DEFAULT ('') NOT NULL ,
	[clan_tag] [varchar] (255) DEFAULT ('') NOT NULL ,
	[clan_tournaments] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[clan_contact] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[clan_logo] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[clan_owner] [int] DEFAULT (0) NOT NULL ,
	[clan_ownerb] [int] DEFAULT (0) NOT NULL ,
	[bbcode_uid] [varchar] (8) DEFAULT ('') NOT NULL ,
	[bbcode_bitfield] [varchar] (255) DEFAULT ('') NOT NULL ,
	[bbcode_options] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_clans] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_clans] PRIMARY KEY  CLUSTERED 
	(
		[clan_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_clansdata'
*/
CREATE TABLE [phpbb_rivals_clansdata] (
	[clan_id] [int] DEFAULT (0) NOT NULL ,
	[clan_wins] [int] DEFAULT (0) NOT NULL ,
	[clan_losses] [int] DEFAULT (0) NOT NULL ,
	[clan_ties] [int] DEFAULT (0) NOT NULL ,
	[clan_score] [int] DEFAULT (0) NOT NULL ,
	[clan_lastscore] [int] DEFAULT (0) NOT NULL ,
	[clan_streak] [int] DEFAULT (0) NOT NULL ,
	[clan_ladder] [int] DEFAULT (0) NOT NULL ,
	[clan_current_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_last_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_best_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_worst_rank] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO


/*
	Table: 'phpbb_rivals_ladders'
*/
CREATE TABLE [phpbb_rivals_ladders] (
	[ladder_id] [int] IDENTITY (1, 1) NOT NULL ,
	[ladder_name] [varchar] (255) DEFAULT ('') NOT NULL ,
	[ladder_desc] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[ladder_rules] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[ladder_order] [int] DEFAULT (0) NOT NULL ,
	[ladder_rm] [int] DEFAULT (0) NOT NULL ,
	[subladder_order] [int] DEFAULT (0) NOT NULL ,
	[ladder_locked] [int] DEFAULT (0) NOT NULL ,
	[ladder_cl] [int] DEFAULT (1) NOT NULL ,
	[ladder_ranking] [int] DEFAULT (0) NOT NULL ,
	[ladder_parent] [int] DEFAULT (0) NOT NULL ,
	[ladder_platform] [int] DEFAULT (0) NOT NULL ,
	[bbcode_uid] [varchar] (8) DEFAULT ('') NOT NULL ,
	[bbcode_bitfield] [varchar] (255) DEFAULT ('') NOT NULL ,
	[bbcode_options] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_ladders] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_ladders] PRIMARY KEY  CLUSTERED 
	(
		[ladder_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_seasons'
*/
CREATE TABLE [phpbb_rivals_seasons] (
	[season_id] [int] IDENTITY (1, 1) NOT NULL ,
	[season_name] [varchar] (255) DEFAULT ('') NOT NULL ,
	[season_ladder] [int] DEFAULT (0) NOT NULL ,
	[season_status] [int] DEFAULT (1) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_seasons] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_seasons] PRIMARY KEY  CLUSTERED 
	(
		[season_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_seasondata'
*/
CREATE TABLE [phpbb_rivals_seasondata] (
	[season_id] [int] DEFAULT (0) NOT NULL ,
	[clan_id] [int] DEFAULT (0) NOT NULL ,
	[clan_wins] [int] DEFAULT (0) NOT NULL ,
	[clan_losses] [int] DEFAULT (0) NOT NULL ,
	[clan_score] [int] DEFAULT (0) NOT NULL ,
	[clan_streak] [int] DEFAULT (0) NOT NULL ,
	[clan_current_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_last_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_ladder] [int] DEFAULT (0) NOT NULL ,
	[clan_best_rank] [int] DEFAULT (0) NOT NULL ,
	[clan_worst_rank] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO


/*
	Table: 'phpbb_rivals_matchcomm'
*/
CREATE TABLE [phpbb_rivals_matchcomm] (
	[match_id] [int] DEFAULT (0) NOT NULL ,
	[clan_id] [int] DEFAULT (0) NOT NULL ,
	[matchcomm_message] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[matchcomm_time] [int] DEFAULT (0) NOT NULL ,
	[matchcomm_unread] [int] DEFAULT (1) NOT NULL 
) ON [PRIMARY]
GO


/*
	Table: 'phpbb_rivals_matches'
*/
CREATE TABLE [phpbb_rivals_matches] (
	[match_id] [int] IDENTITY (1, 1) NOT NULL ,
	[match_ladder] [int] DEFAULT (0) NOT NULL ,
	[match_challenger] [int] DEFAULT (0) NOT NULL ,
	[match_challengee] [int] DEFAULT (0) NOT NULL ,
	[match_status] [int] DEFAULT (0) NOT NULL ,
	[match_finishtime] [int] DEFAULT (0) NOT NULL ,
	[match_posttime] [int] DEFAULT (0) NOT NULL ,
	[match_details] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[match_winner] [int] DEFAULT (0) NOT NULL ,
	[match_looser] [int] DEFAULT (0) NOT NULL ,
	[match_winnerscore] [int] DEFAULT (0) NOT NULL ,
	[match_looserscore] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_matches] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_matches] PRIMARY KEY  CLUSTERED 
	(
		[match_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_matchfinder'
*/
CREATE TABLE [phpbb_rivals_matchfinder] (
	[match_id] [int] IDENTITY (1, 1) NOT NULL ,
	[match_clanid] [int] DEFAULT (0) NOT NULL ,
	[match_ladder] [int] DEFAULT (0) NOT NULL ,
	[match_time] [int] DEFAULT (0) NOT NULL ,
	[match_initaltime] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_matchfinder] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_matchfinder] PRIMARY KEY  CLUSTERED 
	(
		[match_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_platforms'
*/
CREATE TABLE [phpbb_rivals_platforms] (
	[platform_id] [int] IDENTITY (1, 1) NOT NULL ,
	[platform_name] [varchar] (255) DEFAULT ('') NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_platforms] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_platforms] PRIMARY KEY  CLUSTERED 
	(
		[platform_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_tclans'
*/
CREATE TABLE [phpbb_rivals_tclans] (
	[clan_tournament] [int] DEFAULT (0) NOT NULL ,
	[clan_id] [int] DEFAULT (0) NOT NULL ,
	[clan_bracket] [int] DEFAULT (0) NOT NULL ,
	[clan_position] [int] DEFAULT (0) NOT NULL ,
	[clan_looser] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO


/*
	Table: 'phpbb_rivals_tournaments'
*/
CREATE TABLE [phpbb_rivals_tournaments] (
	[tournament_id] [int] IDENTITY (1, 1) NOT NULL ,
	[tournament_name] [varchar] (255) DEFAULT ('') NOT NULL ,
	[tournament_brackets] [int] DEFAULT (0) NOT NULL ,
	[tournament_status] [int] DEFAULT (0) NOT NULL ,
	[tournament_type] [int] DEFAULT (0) NOT NULL ,
	[tournament_season] [int] DEFAULT (0) NOT NULL ,
	[tournament_finishedclans] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[tournament_info] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[tournament_direction] [int] DEFAULT (0) NOT NULL ,
	[tournament_time] [int] DEFAULT (0) NOT NULL ,
	[tournament_startdate] [int] DEFAULT (0) NOT NULL ,
	[tournament_ladder] [int] DEFAULT (0) NOT NULL ,
	[tournament_rm] [int] DEFAULT (0) NOT NULL ,
	[bbcode_uid] [varchar] (8) DEFAULT ('') NOT NULL ,
	[bbcode_bitfield] [varchar] (255) DEFAULT ('') NOT NULL ,
	[bbcode_options] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_tournaments] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_tournaments] PRIMARY KEY  CLUSTERED 
	(
		[tournament_id]
	)  ON [PRIMARY] 
GO


/*
	Table: 'phpbb_rivals_treports'
*/
CREATE TABLE [phpbb_rivals_treports] (
	[report_id] [int] IDENTITY (1, 1) NOT NULL ,
	[report_tournament] [int] DEFAULT (0) NOT NULL ,
	[clan_1] [varchar] (255) DEFAULT ('') NOT NULL ,
	[clan_2] [varchar] (255) DEFAULT ('') NOT NULL ,
	[clan_r1] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[clan_r2] [varchar] (4000) DEFAULT ('') NOT NULL ,
	[report_time] [int] DEFAULT (0) NOT NULL ,
	[clan_1id] [int] DEFAULT (0) NOT NULL ,
	[clan_2id] [int] DEFAULT (0) NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [phpbb_rivals_treports] WITH NOCHECK ADD 
	CONSTRAINT [PK_phpbb_rivals_treports] PRIMARY KEY  CLUSTERED 
	(
		[report_id]
	)  ON [PRIMARY] 
GO



COMMIT
GO

