#
# $Id: $
#

# Table: 'phpbb_rivals_challenges'
CREATE TABLE phpbb_rivals_challenges (
	challenge_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	challenge_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	challenger mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	challengee mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	challenge_posttime int(11) DEFAULT '0' NOT NULL,
	challenge_details blob NOT NULL,
	PRIMARY KEY (challenge_id)
);


# Table: 'phpbb_rivals_clanmembers'
CREATE TABLE phpbb_rivals_clanmembers (
	member_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	member_clan mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	member_userid mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	member_status smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (member_id)
);


# Table: 'phpbb_rivals_clans'
CREATE TABLE phpbb_rivals_clans (
	clan_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	clan_name varbinary(255) DEFAULT '' NOT NULL,
	clan_tag varbinary(255) DEFAULT '' NOT NULL,
	clan_tournaments blob NOT NULL,
	clan_contact blob NOT NULL,
	clan_logo blob NOT NULL,
	clan_owner mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_ownerb mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	bbcode_uid varbinary(8) DEFAULT '' NOT NULL,
	bbcode_bitfield varbinary(255) DEFAULT '' NOT NULL,
	bbcode_options int(4) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (clan_id)
);


# Table: 'phpbb_rivals_clansdata'
CREATE TABLE phpbb_rivals_clansdata (
	clan_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_wins mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_losses mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_ties mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_score mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_lastscore mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_streak mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_current_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_last_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_best_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_worst_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL
);


# Table: 'phpbb_rivals_ladders'
CREATE TABLE phpbb_rivals_ladders (
	ladder_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	ladder_name varbinary(255) DEFAULT '' NOT NULL,
	ladder_desc blob NOT NULL,
	ladder_rules blob NOT NULL,
	ladder_order mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	ladder_rm mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	subladder_order mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	ladder_locked tinyint(2) DEFAULT '0' NOT NULL,
	ladder_cl tinyint(2) DEFAULT '1' NOT NULL,
	ladder_ranking tinyint(2) DEFAULT '0' NOT NULL,
	ladder_parent mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	ladder_platform mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	bbcode_uid varbinary(8) DEFAULT '' NOT NULL,
	bbcode_bitfield varbinary(255) DEFAULT '' NOT NULL,
	bbcode_options int(4) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (ladder_id)
);


# Table: 'phpbb_rivals_seasons'
CREATE TABLE phpbb_rivals_seasons (
	season_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	season_name varbinary(255) DEFAULT '' NOT NULL,
	season_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	season_status tinyint(2) DEFAULT '1' NOT NULL,
	PRIMARY KEY (season_id)
);


# Table: 'phpbb_rivals_seasondata'
CREATE TABLE phpbb_rivals_seasondata (
	season_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_wins mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_losses mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_score mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_streak int(8) DEFAULT '0' NOT NULL,
	clan_current_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_last_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_best_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_worst_rank mediumint(8) UNSIGNED DEFAULT '0' NOT NULL
);


# Table: 'phpbb_rivals_matchcomm'
CREATE TABLE phpbb_rivals_matchcomm (
	match_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	matchcomm_message blob NOT NULL,
	matchcomm_time int(11) DEFAULT '0' NOT NULL,
	matchcomm_unread tinyint(2) DEFAULT '1' NOT NULL
);


# Table: 'phpbb_rivals_matches'
CREATE TABLE phpbb_rivals_matches (
	match_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	match_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_challenger mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_challengee mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_status smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	match_finishtime int(11) DEFAULT '0' NOT NULL,
	match_posttime int(11) DEFAULT '0' NOT NULL,
	match_details blob NOT NULL,
	match_winner mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_looser mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_winnerscore mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_looserscore mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (match_id)
);


# Table: 'phpbb_rivals_matchfinder'
CREATE TABLE phpbb_rivals_matchfinder (
	match_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	match_clanid mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	match_time int(11) DEFAULT '0' NOT NULL,
	match_initaltime int(11) DEFAULT '0' NOT NULL,
	PRIMARY KEY (match_id)
);


# Table: 'phpbb_rivals_platforms'
CREATE TABLE phpbb_rivals_platforms (
	platform_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	platform_name varbinary(255) DEFAULT '' NOT NULL,
	PRIMARY KEY (platform_id)
);


# Table: 'phpbb_rivals_tclans'
CREATE TABLE phpbb_rivals_tclans (
	clan_tournament mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_bracket mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_position mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_looser tinyint(2) DEFAULT '0' NOT NULL
);


# Table: 'phpbb_rivals_tournaments'
CREATE TABLE phpbb_rivals_tournaments (
	tournament_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	tournament_name varbinary(255) DEFAULT '' NOT NULL,
	tournament_brackets mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	tournament_status smallint(4) UNSIGNED DEFAULT '0' NOT NULL,
	tournament_type mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	tournament_season mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	tournament_finishedclans blob NOT NULL,
	tournament_info blob NOT NULL,
	tournament_direction tinyint(2) DEFAULT '0' NOT NULL,
	tournament_time int(11) DEFAULT '0' NOT NULL,
	tournament_startdate int(11) DEFAULT '0' NOT NULL,
	tournament_ladder mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	tournament_rm mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	bbcode_uid varbinary(8) DEFAULT '' NOT NULL,
	bbcode_bitfield varbinary(255) DEFAULT '' NOT NULL,
	bbcode_options int(4) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (tournament_id)
);


# Table: 'phpbb_rivals_treports'
CREATE TABLE phpbb_rivals_treports (
	report_id mediumint(8) UNSIGNED NOT NULL auto_increment,
	report_tournament mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_1 varbinary(255) DEFAULT '' NOT NULL,
	clan_2 varbinary(255) DEFAULT '' NOT NULL,
	clan_r1 blob NOT NULL,
	clan_r2 blob NOT NULL,
	report_time int(11) DEFAULT '0' NOT NULL,
	clan_1id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	clan_2id mediumint(8) UNSIGNED DEFAULT '0' NOT NULL,
	PRIMARY KEY (report_id)
);


