#
# $Id: $
#

BEGIN TRANSACTION;

# Table: 'phpbb_rivals_challenges'
CREATE TABLE phpbb_rivals_challenges (
	challenge_id INTEGER PRIMARY KEY NOT NULL ,
	challenge_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	challenger INTEGER UNSIGNED NOT NULL DEFAULT '0',
	challengee INTEGER UNSIGNED NOT NULL DEFAULT '0',
	challenge_posttime int(11) NOT NULL DEFAULT '0',
	challenge_details text(65535) NOT NULL DEFAULT ''
);


# Table: 'phpbb_rivals_clanmembers'
CREATE TABLE phpbb_rivals_clanmembers (
	member_id INTEGER PRIMARY KEY NOT NULL ,
	member_clan INTEGER UNSIGNED NOT NULL DEFAULT '0',
	member_userid INTEGER UNSIGNED NOT NULL DEFAULT '0',
	member_status INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_clans'
CREATE TABLE phpbb_rivals_clans (
	clan_id INTEGER PRIMARY KEY NOT NULL ,
	clan_name varchar(255) NOT NULL DEFAULT '',
	clan_tag varchar(255) NOT NULL DEFAULT '',
	clan_tournaments text(65535) NOT NULL DEFAULT '',
	clan_contact text(65535) NOT NULL DEFAULT '',
	clan_logo text(65535) NOT NULL DEFAULT '',
	clan_owner INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_ownerb INTEGER UNSIGNED NOT NULL DEFAULT '0',
	bbcode_uid varchar(8) NOT NULL DEFAULT '',
	bbcode_bitfield varchar(255) NOT NULL DEFAULT '',
	bbcode_options INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_clansdata'
CREATE TABLE phpbb_rivals_clansdata (
	clan_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_wins INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_losses INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_ties INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_score INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_lastscore INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_streak INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_current_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_last_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_best_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_worst_rank INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_ladders'
CREATE TABLE phpbb_rivals_ladders (
	ladder_id INTEGER PRIMARY KEY NOT NULL ,
	ladder_name varchar(255) NOT NULL DEFAULT '',
	ladder_desc text(65535) NOT NULL DEFAULT '',
	ladder_rules text(65535) NOT NULL DEFAULT '',
	ladder_order INTEGER UNSIGNED NOT NULL DEFAULT '0',
	ladder_rm INTEGER UNSIGNED NOT NULL DEFAULT '0',
	subladder_order INTEGER UNSIGNED NOT NULL DEFAULT '0',
	ladder_locked tinyint(2) NOT NULL DEFAULT '0',
	ladder_cl tinyint(2) NOT NULL DEFAULT '1',
	ladder_ranking tinyint(2) NOT NULL DEFAULT '0',
	ladder_parent INTEGER UNSIGNED NOT NULL DEFAULT '0',
	ladder_platform INTEGER UNSIGNED NOT NULL DEFAULT '0',
	bbcode_uid varchar(8) NOT NULL DEFAULT '',
	bbcode_bitfield varchar(255) NOT NULL DEFAULT '',
	bbcode_options INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_seasons'
CREATE TABLE phpbb_rivals_seasons (
	season_id INTEGER PRIMARY KEY NOT NULL ,
	season_name varchar(255) NOT NULL DEFAULT '',
	season_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	season_status tinyint(2) NOT NULL DEFAULT '1'
);


# Table: 'phpbb_rivals_seasondata'
CREATE TABLE phpbb_rivals_seasondata (
	season_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_wins INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_losses INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_score INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_streak int(8) NOT NULL DEFAULT '0',
	clan_current_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_last_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_best_rank INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_worst_rank INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_matchcomm'
CREATE TABLE phpbb_rivals_matchcomm (
	match_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	matchcomm_message text(65535) NOT NULL DEFAULT '',
	matchcomm_time int(11) NOT NULL DEFAULT '0',
	matchcomm_unread tinyint(2) NOT NULL DEFAULT '1'
);


# Table: 'phpbb_rivals_matches'
CREATE TABLE phpbb_rivals_matches (
	match_id INTEGER PRIMARY KEY NOT NULL ,
	match_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_challenger INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_challengee INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_status INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_finishtime int(11) NOT NULL DEFAULT '0',
	match_posttime int(11) NOT NULL DEFAULT '0',
	match_details text(65535) NOT NULL DEFAULT '',
	match_winner INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_looser INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_winnerscore INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_looserscore INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_matchfinder'
CREATE TABLE phpbb_rivals_matchfinder (
	match_id INTEGER PRIMARY KEY NOT NULL ,
	match_clanid INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	match_time int(11) NOT NULL DEFAULT '0',
	match_initaltime int(11) NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_platforms'
CREATE TABLE phpbb_rivals_platforms (
	platform_id INTEGER PRIMARY KEY NOT NULL ,
	platform_name varchar(255) NOT NULL DEFAULT ''
);


# Table: 'phpbb_rivals_tclans'
CREATE TABLE phpbb_rivals_tclans (
	clan_tournament INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_bracket INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_position INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_looser tinyint(2) NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_tournaments'
CREATE TABLE phpbb_rivals_tournaments (
	tournament_id INTEGER PRIMARY KEY NOT NULL ,
	tournament_name varchar(255) NOT NULL DEFAULT '',
	tournament_brackets INTEGER UNSIGNED NOT NULL DEFAULT '0',
	tournament_status INTEGER UNSIGNED NOT NULL DEFAULT '0',
	tournament_type INTEGER UNSIGNED NOT NULL DEFAULT '0',
	tournament_season INTEGER UNSIGNED NOT NULL DEFAULT '0',
	tournament_finishedclans text(65535) NOT NULL DEFAULT '',
	tournament_info text(65535) NOT NULL DEFAULT '',
	tournament_direction tinyint(2) NOT NULL DEFAULT '0',
	tournament_time int(11) NOT NULL DEFAULT '0',
	tournament_startdate int(11) NOT NULL DEFAULT '0',
	tournament_ladder INTEGER UNSIGNED NOT NULL DEFAULT '0',
	tournament_rm INTEGER UNSIGNED NOT NULL DEFAULT '0',
	bbcode_uid varchar(8) NOT NULL DEFAULT '',
	bbcode_bitfield varchar(255) NOT NULL DEFAULT '',
	bbcode_options INTEGER UNSIGNED NOT NULL DEFAULT '0'
);


# Table: 'phpbb_rivals_treports'
CREATE TABLE phpbb_rivals_treports (
	report_id INTEGER PRIMARY KEY NOT NULL ,
	report_tournament INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_1 varchar(255) NOT NULL DEFAULT '',
	clan_2 varchar(255) NOT NULL DEFAULT '',
	clan_r1 text(65535) NOT NULL DEFAULT '',
	clan_r2 text(65535) NOT NULL DEFAULT '',
	report_time int(11) NOT NULL DEFAULT '0',
	clan_1id INTEGER UNSIGNED NOT NULL DEFAULT '0',
	clan_2id INTEGER UNSIGNED NOT NULL DEFAULT '0'
);



COMMIT;