/*

 $Id: $

*/

/*
  This first section is optional, however its probably the best method
  of running phpBB on Oracle. If you already have a tablespace and user created
  for phpBB you can leave this section commented out!

  The first set of statements create a phpBB tablespace and a phpBB user,
  make sure you change the password of the phpBB user before you run this script!!
*/

/*
CREATE TABLESPACE "PHPBB"
	LOGGING
	DATAFILE 'E:\ORACLE\ORADATA\LOCAL\PHPBB.ora'
	SIZE 10M
	AUTOEXTEND ON NEXT 10M
	MAXSIZE 100M;

CREATE USER "PHPBB"
	PROFILE "DEFAULT"
	IDENTIFIED BY "phpbb_password"
	DEFAULT TABLESPACE "PHPBB"
	QUOTA UNLIMITED ON "PHPBB"
	ACCOUNT UNLOCK;

GRANT ANALYZE ANY TO "PHPBB";
GRANT CREATE SEQUENCE TO "PHPBB";
GRANT CREATE SESSION TO "PHPBB";
GRANT CREATE TABLE TO "PHPBB";
GRANT CREATE TRIGGER TO "PHPBB";
GRANT CREATE VIEW TO "PHPBB";
GRANT "CONNECT" TO "PHPBB";

COMMIT;
DISCONNECT;

CONNECT phpbb/phpbb_password;
*/
/*
	Table: 'phpbb_rivals_seasons'
*/
CREATE TABLE phpbb_rivals_seasons (
	season_id number(8) NOT NULL,
	season_name varchar2(255) DEFAULT '' ,
	season_ladder number(8) DEFAULT '0' NOT NULL,
	season_status number(2) DEFAULT '1' NOT NULL,
	CONSTRAINT pk_phpbb_rivals_seasons PRIMARY KEY (season_id)
)
/


CREATE SEQUENCE phpbb_rivals_seasons_seq
/

CREATE OR REPLACE TRIGGER t_phpbb_rivals_seasons
BEFORE INSERT ON phpbb_rivals_seasons
FOR EACH ROW WHEN (
	new.season_id IS NULL OR new.season_id = 0
)
BEGIN
	SELECT phpbb_rivals_seasons_seq.nextval
	INTO :new.season_id
	FROM dual;
END;
/


/*
	Table: 'phpbb_rivals_seasondata'
*/
CREATE TABLE phpbb_rivals_seasondata (
	season_id number(8) DEFAULT '0' NOT NULL,
	clan_id number(8) DEFAULT '0' NOT NULL,
	clan_wins number(8) DEFAULT '0' NOT NULL,
	clan_losses number(8) DEFAULT '0' NOT NULL,
	clan_ties number(8) DEFAULT '0' NOT NULL,
	clan_score number(8) DEFAULT '0' NOT NULL,
	clan_streak number(8) DEFAULT '0' NOT NULL,
	clan_current_rank number(8) DEFAULT '0' NOT NULL,
	clan_last_rank number(8) DEFAULT '0' NOT NULL,
	clan_ladder number(8) DEFAULT '0' NOT NULL,
	clan_best_rank number(8) DEFAULT '0' NOT NULL,
	clan_worst_rank number(8) DEFAULT '0' NOT NULL
)
/


