<?php
##############################################################
# FILENAME  : add_clan.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

$ladder		= new ladder ( );

// Are we submitting a form?
$submit	= request_var ( 'submit', '' );
if ( !empty ( $submit ) )
{
	// Check to see if the details have been entered.
	$clan_name	= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_name', '', true ) ) );
	if ( !empty ( $clan_name ) )
	{
		$clan_tag		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_tag', '', true ) ) );
		$clan_info		= $db->sql_escape ( utf8_normalize_nfc ( request_var ( 'clan_info', '', true ) ) );
		$clan_logo		= $db->sql_escape ( request_var ( 'clan_logo', '' ) );

		// Setup the BBcode for the ladder rules.
		$uid			= $bitfield = $options = '';
		$allow_bbcode	= $allow_urls = $allow_smilies = true;
		generate_text_for_storage ( $clan_info, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies );

		// Insert the clan into the database.
		$sql_array	= array (
			'clan_name' => $clan_name,
			'clan_tag' => $clan_tag,
			'clan_contact' => $clan_info,
			'clan_logo' => $clan_logo,
			'clan_owner' => $user->data[ 'user_id' ],
			'clan_ownerb' => 0,
			'clan_tournaments' => '',
			'bbcode_uid' => $uid,
			'bbcode_bitfield' => $bitfield,
			'bbcode_options' => $options
		);
		$sql		= "INSERT INTO " . CLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
		$db->sql_query ( $sql );

		// Check to see if this is their first clan.
		if ( $user->data[ 'clan_session' ] == 0 )
		{
			// Set their clan session.
			$sql	= "UPDATE " . USERS_TABLE . " SET clan_session = " . $db->sql_nextid ( ) . " WHERE user_id = " . $user->data[ 'user_id' ];
			$db->sql_query ( $sql );
		}

		// Completed. Let the user know.
		trigger_error ( 'CLAN_ADDED' );
	}
	else
	{
		// Enter details. Let the user know.
		trigger_error ( 'ENTER_CLAN_NAME' );
	}
}
else
{
	// Check to see if the user is logged in.
	if ( !$user->data[ 'is_registered' ] )
	{
		trigger_error ( 'LOGIN' );
	}

	// Assign the other variable to the template.	
	$template->assign_vars ( array ( 'U_ACTION' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=add_clan' ) ) );
	$template->set_filenames ( array ( 'body' => 'rivals/add_clan.html' ) );
}

?>
