<?php
##############################################################
# FILENAME  : clan_list.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

$clan		= new clan ( );
$ladder		= new ladder ( );
$start		= request_var ( 'start', 0 );

// Get the clan's data.
$sql	= "SELECT cl.*, cd.* FROM " . CLANS_TABLE . " cl, " . CLANDATA_TABLE . " cd WHERE cd.clan_id = cl.clan_id ";
$where	= "";

$ladder_id	= request_var ( 'ladder_id', 0 );
if ( $ladder_id != 0 )
{
	// Filtering for ladder.
	$where	= "AND cd.clan_ladder = $ladder_id ";
}

$alpha	= request_var ( 'alpha', '' );
if ( $alpha != '' )
{
	// Filtering for name.
	$where	= "AND (cl.clan_name LIKE '" . strtoupper ( $alpha ) . "%' OR cl.clan_name LIKE '" . strtolower ( $alpha ) . "%') ";
}

// Combine the SQL and the WHERE.
$sql	.= $where . "GROUP BY cd.clan_id ORDER BY clan_name ASC";
$result	= $db->sql_query_limit ( $sql, 15, $start );

$i	= 0;
while ( $row = $db->sql_fetchrow ( $result ) )
{
	// Get the members joined to the clan.
	$sql_2		= "SELECT COUNT(member_userid) AS total FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = " . $row[ 'clan_id' ];
	$result_2	= $db->sql_query ( $sql_2 );
	$row_2		= $db->sql_fetchrow ( $result_2 );
	$db->sql_freeresult ( $result_2 );

	// Assign the clans to the template.
	$template->assign_block_vars ( 'block_clans', array (
		'U_ACTION' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_profile&amp;clan_id=' . $row[ 'clan_id' ] ),
		'CLAN_NAME' => $row[ 'clan_name' ],
		'CLAN_TAG' => $row[ 'clan_tag' ],
		'CLAN_MEMBERS' => $row_2[ 'total' ],
		'BG_COLOR' => ( $i % 2 ) ? 'bg1' : 'bg2',
		'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
	);

	// Check if a challenge link is to be showen.
	if ( $row[ 'clan_owner' ] != $user->data[ 'user_id' ] && $user->data[ 'user_id' ] != ANONYMOUS )
	{
		// Show the challenge link.
		$template->assign_block_vars ( 'block_clans.block_challenge', array (
			'U_CHALLENGE' => append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=add_challenge&amp;clan_id=' . $row[ 'clan_id' ] ) )
		);
	}

	$i++;
}

$db->sql_freeresult ( $result );

// Setup the alphas.
$alphas	= range ( 'a', 'z' );
foreach ( $alphas AS $value )
{
	// Show the A B Cs!
	$template->assign_block_vars ( 'block_alphas', array (
		'U_ALPHA' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_list&amp;ladder_id=' . $ladder_id . '&amp;alpha=' . $value ),
		'ALPHA' => $value )
	);
}

// Loop through the ladder list.
$ladders	= $ladder->ladder_list ( );
foreach ( $ladders AS $key => $value )
{
	$sql	= "SELECT * FROM " . PLATFORMS_TABLE . " WHERE platform_id = " . $ladders[ $key ][ 'PLATFORM' ];
	$result	= $db->sql_query ( $sql );
	$row	= $db->sql_fetchrow ( $result );

	// Assign it to the template.
	$template->assign_block_vars ( 'block_ladders', array (
		'LADDER_NAME' => $ladders[ $key ][ 'NAME' ],
		'PLATFORM' => $row[ 'platform_name' ] )
	);

	// Loop through the ladder's sub-ladders.
	foreach ( $ladders[ $key ][ 'SUBLADDERS' ] AS $key_2 => $value_2 )
	{
		// Assign them to the template.
		$template->assign_block_vars ( 'block_ladders.block_subladders', array (
			'LADDER_NAME' => $ladders[ $key ][ 'SUBLADDERS' ][ $key_2 ][ 'NAME' ],
			'LADDER_ID' => $key_2 )
		);
	}
}

// Setup the pagination.
$sql	= "SELECT cl.*, cd.* AS total FROM " . CLANS_TABLE . " cl, " . CLANDATA_TABLE . " cd WHERE cl.clan_id = cd.clan_id $where GROUP BY cd.clan_id";
$result	= $db->sql_query ( $sql );
$total	= sizeof ( $db->sql_fetchrowset ( $result ) );
$db->sql_freeresult ( $result );

// Generate the pagination.
$pagination	= generate_pagination ( append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_list&amp;ladder_id=' . $ladder_id . '&amp;alpha=' . $alpha ), $total, 15, $start );

// Assign the other variables to the template.
$template->assign_vars ( array (
	'U_ACTION' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_list&amp;alpha=' . $alpha ),
	'PAGINATION' => $pagination,
	'PAGE_NUMBER' => on_page ( $total, 15, $start ) )
);

$template->set_filenames ( array ( 'body' => 'rivals/clan_list.html' ) );

?>
