<?php
##############################################################
# FILENAME  : clan_profile.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

$clan		= new clan ( );
$ladder		= new ladder ( );

$clan_id		= request_var ( 'clan_id', 0 );
$season_id		= request_var ( 'season_id', 0 );
$season_ladder	= request_var ( 'season_ladder', 0 );
$clan_data		= $clan->data ( '*', $clan_id );

include ( $phpbb_root_path . 'includes/functions_display.' . $phpEx );

$sql	= "SELECT * FROM " . USERS_TABLE . " WHERE user_id = " . $clan_data[ 'clan_owner' ];
$result	= $db->sql_query ( $sql );
$row	= $db->sql_fetchrow ( $result );
$db->sql_freeresult ( $result );

// Assign the leader's data to the template.
$template->assign_vars ( array (
	'U_LEADERPROFILE' => append_sid ( "{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&amp;u=' . $row[ 'user_id' ] ),
	'U_CHALLENGE' => append_sid ( "{$phpbb_root_path}ucp.$phpEx", 'i=rivals&amp;mode=add_challenge&amp;clan_id=' . $clan_id ),
	'LEADER_NAME' => $row[ 'username' ] )
);

// Get the list of clan members for the clan.
$sql	= "SELECT * FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = $clan_id AND member_userid <> {$clan_data[ 'clan_owner' ]} AND member_status = 1";
$result	= $db->sql_query ( $sql );

$i	= 0;
while ( $row = $db->sql_fetchrow ( $result ) )
{
	$sql_2		= "SELECT * FROM " . USERS_TABLE . " WHERE user_id = " . $row[ 'member_userid' ];
	$result_2	= $db->sql_query ( $sql_2 );
	$row_2		= $db->sql_fetchrow ( $result_2 );

	// Assign the member's data to the template.
	$template->assign_block_vars ( 'block_members', array (
		'U_MEMBERPROFILE' => append_sid ( "{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&amp;u=' . $row_2[ 'user_id' ] ),
		'MEMBER_NAME' => $row_2[ 'username' ],
		'CLAN_TAG' => $clan_data[ 'clan_tag' ],
		'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2' )
	);

	$i++;
}

$db->sql_freeresult ( $result );

// Get the on-going and finished matches from the database.
$sql	= "SELECT m.*, l.* FROM " . MATCHES_TABLE . " m, " . LADDERS_TABLE . " l WHERE (m.match_challenger = $clan_id OR m.match_challengee = $clan_id) AND m.match_ladder = l.ladder_id ORDER BY m.match_id DESC";
$result	= $db->sql_query ( $sql );

$i	= 0;
while ( $row = $db->sql_fetchrow ( $result ) )
{
	// Get the ladder's roots.
	$ladder_data	= $ladder->get_roots ( $row[ 'match_ladder' ] );

	// Assign each match to the template.
	$template->assign_block_vars ( 'block_matchhistory', array (
		'PLATFORM' => $ladder_data[ 'PLATFORM_NAME' ],
		'LADDER' => $ladder_data[ 'LADDER_NAME' ],
		'SUBLADDER' => $ladder_data[ 'SUBLADDER_NAME' ],
		'ROW_COLOR' => ( $i % 2 ) ? 'row1' : 'row2',
		'STATUS' => ( $row[ 'match_finishtime' ] > 0 ) ? $user->lang[ 'FINISHED' ] : $user->lang[ 'ONGOING' ],
		'DATE' => ( $row[ 'match_finishtime' ] > 0 ) ? $user->format_date ( $row[ 'match_finishtime' ] ) : $user->format_date ( $row[ 'match_posttime' ] ),
		'CHALLENGER' => ( $row[ 'match_challenger' ] == $clan_id ) ? '<strong>' . $clan->data ( 'clan_name', $row[ 'match_challenger' ] ) . '</strong>' : $clan->data ( 'clan_name', $row[ 'match_challenger' ] ),
		'CHALLENGEE' => ( $row[ 'match_challengee' ] == $clan_id ) ? '<strong>' . $clan->data ( 'clan_name', $row[ 'match_challengee' ] ) . '</strong>' : $clan->data ( 'clan_name', $row[ 'match_challengee' ] ),
		'WINNER' => ( $row[ 'match_tie' ] != 0 ) ? $user->lang[ 'TIE' ] : ( ( $row[ 'match_finishtime' ] > 0 ) ? $clan->data ( 'clan_name', $row[ 'match_winner' ] ) : '-' ) )
	);

	$i++;
}

$db->sql_freeresult ( $result );

// Check if we need to show the "Request to Join".
$sql	= "SELECT * FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = $clan_id AND member_userid = " . $user->data[ 'user_id' ];
$result	= $db->sql_query ( $sql );
$row	= $db->sql_fetchrow ( $result );
$db->sql_freeresult ( $result );

if ( sizeof ( $row ) == 0 && $user->data[ 'user_id' ] != $clan_data[ 'clan_owner' ] && $user->data[ 'user_id' ] != $clan_data[ 'clan_ownerb' ] )
{
	// The user is not in the clan so show the message.
	$template->assign_block_vars ( 'block_request', array ( 'U_REQUEST' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=join_clan&amp;type=1&amp;clan_id=' . $clan_id ) ) );
}

// Get the ladders the clan is joined to.
$sql	= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_id = " . $clan_id;
$result	= $db->sql_query ( $sql );

while ( $row = $db->sql_fetchrow ( $result ) )
{
	// Get the ladder's roots.
	$ladder_data	= $ladder->get_roots ( $row[ 'clan_ladder' ] );

	// Get the season for this ladder.
	$sql_2		= "SELECT * FROM " . SEASONS_TABLE . " WHERE season_ladder = {$row[ 'clan_ladder' ]} AND season_status = 1";
	$result_2	= $db->sql_query ( $sql_2 );
	$row_2		= $db->sql_fetchrow ( $result_2 );
	$db->sql_freeresult ( $result_2 );

	// Check where to get the data.
	if ( $season_id != 0 && $season_ladder == $row[ 'clan_ladder' ] )
	{
		// User selected to see archived season data.
		$sql_2		= "SELECT * FROM " . SEASONS_TABLE . " WHERE season_id = " . $season_id;
		$result_2	= $db->sql_query ( $sql_2 );
		$row_2		= $db->sql_fetchrow ( $result_2 );
		$db->sql_freeresult ( $result_2 );

		$sql_3		= "SELECT * FROM " . SEASONDATA_TABLE . " WHERE season_id = $season_id AND clan_id = " . $clan_id;
		$result_3	= $db->sql_query ( $sql_3 );
		$data		= $db->sql_fetchrow ( $result_3 );
		$db->sql_freeresult ( $result_3 );
	}
	else
	{
		// User needs to see the current season.
		$data	= $row;
	}

	// Assign the ladder and the stats to the template.
	$template->assign_block_vars ( 'block_ladders', array (
		'U_ACTION' => append_sid ( "{$phpbb_root_path}rivals.$phpEx", 'action=clan_profile&amp;clan_id=' . $clan_id ),
		'SEASON_NAME' => ( !empty ( $row_2[ 'season_name' ] ) ) ? $row_2[ 'season_name' ] : $user->lang[ 'CURRENT_SEASON' ],
		'PLATFORM' => $ladder_data[ 'PLATFORM_NAME' ],
		'LADDER' => $ladder_data[ 'LADDER_NAME' ],
		'SUBLADDER_ID' => $ladder_data[ 'SUBLADDER_ID' ],
		'SUBLADDER' => $ladder_data[ 'SUBLADDER_NAME' ],
		'CLAN_WINS' => $data[ 'clan_wins' ],
		'CLAN_LOSSES' => $data[ 'clan_losses' ],
		'CLAN_STREAK' => $data[ 'clan_streak' ],
		'CLAN_SCORE' => $data[ 'clan_score' ],
		'CURRENT_RANK' => $data[ 'clan_current_rank' ],
		'LAST_RANK' => $data[ 'clan_last_rank' ],
		'BEST_RANK' => $data[ 'clan_best_rank' ],
		'WORST_RANK' => $data[ 'clan_worst_rank' ] )
	);

	// Get all the seasons for this ladder.
	$sql_4		= "SELECT s.*, sd.* FROM " . SEASONS_TABLE . " s, " . SEASONDATA_TABLE . " sd WHERE s.season_ladder = {$row[ 'clan_ladder' ]} AND sd.clan_ladder = {$row[ 'clan_ladder' ]} AND sd.clan_id = " . $clan_id;
	$result_4	= $db->sql_query ( $sql_4 );

	while ( $row_4 = $db->sql_fetchrow ( $result_4 ) )
	{
		// Assign each season to the template.
		$template->assign_block_vars ( 'block_ladders.block_seasons', array (
			'SEASON_ID' => $row_4[ 'season_id' ],
			'SEASON_NAME' => $row_4[ 'season_name' ] )
		);
	}

	$db->sql_freeresult ( $result_4 );
}

$db->sql_freeresult ( $result );

// Setup the BBcode for the clan description.
$desc	= nl2br ( generate_text_for_display ( $clan_data[ 'clan_contact' ], $clan_data[ 'bbcode_uid' ], $clan_data[ 'bbcode_bitfield' ], $clan_data[ 'bbcode_options' ] ) );

// Assign the other variables to the template.
$template->assign_vars ( array (
	'CLAN_ID' => $clan_id,
	'CLAN_LOGO' => $clan_data[ 'clan_logo' ],
	'CLAN_NAME' => $clan_data[ 'clan_name' ],
	'CLAN_CONTACT' => ( !empty ( $desc ) ) ? $desc : '-' )
);

$template->set_filenames ( array ( 'body' => 'rivals/clan_profile.html' ) );

?>
