<?php
##############################################################
# FILENAME  : class_clan.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

/**
 * Clan Class
 * This takes clan information from the user's clan in session, or takes information from the DB for a specific clan.
 */
class clan
{
	/**
	 * Contains the clan's information.
	 *
	 * @var array
	 */
	var $data;

	/**
	 * Contains the clan's ID.
	 *
	 * @var integer
	 */
	var $clan_id;

	/**
	 * Gets the user's clan information.
	 */
	function clan ( )
	{
		global	$db;
		global	$user;

		// Get the clan the user is logged into and grab it's data.
		$sql		= "SELECT clan_session FROM " . USERS_TABLE . " WHERE user_id = " . $user->data[ 'user_id' ];
		$result		= $db->sql_query ( $sql );
		$row		= $db->sql_fetchrow ( $result );

		$this->clan_id	= intval ( $row[ 'clan_session' ] );
		$this->data		= $this->data ( );
	}

	/**
	 * Populates the array of data based on information from the arguments.
	 *
	 * @param string $feild
	 * @param integer $clan_id
	 * @param integer $ladder_id
	 * @return array
	 */
	function data ( $field = '*', $clan_id = 0, $ladder_id = 0 )
	{
		global	$db;

		// Are we dealing with a request or default request?
		$type	= ( $clan_id != 0 ) ? $clan_id : $this->clan_id;

		if ( $ladder_id != 0 )
		{
			// Get the clan's information for a specific ladder.
			$sql	= "SELECT $field FROM " . CLANDATA_TABLE . " WHERE clan_id = $type AND clan_ladder = " . $ladder_id;
			$result	= $db->sql_query ( $sql );
			$row	= $db->sql_fetchrow ( $result );

			if ( $field != '*' )
			{
				// Return the specific feild.
				return	$row[ $field ];
			}
			else
			{
				return	$row;
			}
		}
		else
		{
			if ( $type != 0 )
			{
				// Get the clan's information.
				$sql	= "SELECT $field FROM " . CLANS_TABLE . " WHERE clan_id = " . $type;
				$result	= $db->sql_query ( $sql );
				$row	= $db->sql_fetchrow ( $result );

				if ( $field != '*' )
				{
					// Return the specific feild.
					return	$row[ $field ];
				}
				else
				{
					// Get the ladders the clan is joined to as well.
					$sql	= "SELECT clan_ladder FROM " . CLANDATA_TABLE . " WHERE clan_id = " . $type;
					$result	= $db->sql_query ( $sql );

					$ladders	= array ( );
					while ( $rows = $db->sql_fetchrow ( $result ) )
					{
						$ladders[ ]	= $rows[ 'clan_ladder' ];
					}

					// Return the clan's data and the clan's ladder list.
					return	array_merge ( $row, array ( 'clan_ladders' => $ladders ) );
				}
			}
			else
			{
				// Return an empty array set.
				return	array ( );
			}
		}
	}
}

?>
