<?php
##############################################################
# FILENAME  : ladder_membership.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

$clan		= new clan ( );
$ladder		= new ladder ( );
$type		= request_var ( 'type', 0 );
$ladder_id	= request_var ( 'ladder_id', 0 );

if ( $type == 1 )
{
	// The clan is wishing to join the ladder. Do some checking!
	$sql	= "SELECT * FROM " . CLANDATA_TABLE . " WHERE clan_ladder = $ladder_id AND clan_id = " . $clan->data[ 'clan_id' ];
	$result	= $db->sql_query ( $sql );
	$row	= $db->sql_fetchrow ( $result );

	if ( !empty ( $row[ 'clan_id' ] ) )
	{
		// They are already joined with the ladder. Let the user know.
		trigger_error ( 'ALREADY_IN_LADDER' );
	}

	// Check if there are required members needed.
	if ( $ladder->data[ 'ladder_rm' ] != 0 )
	{
		// Get the members joined to this clan.
		$sql	= "SELECT COUNT(member_userid) AS total FROM " . CLANMEMBERS_TABLE . " WHERE member_clan = {$clan->data[ 'clan_id' ]} AND member_status = 1";
		$result	= $db->sql_query ( $sql );
		$row	= $db->sql_fetchrow ( $result );

		if ( $row[ 'total' ] < $ladder->data[ 'ladder_rm' ] )
		{
			// They do not have enough members. Let the user know.
			trigger_error ( sprintf ( $user->lang[ 'REQUIRED_MEMBERS_FAILED' ], $ladder->data[ 'ladder_rm' ] ) );
		}
	}

	// Everything seems OK. Join them to the ladder.
	$sql		= "SELECT MAX(clan_current_rank) AS current_rank FROM " . CLANDATA_TABLE . " WHERE clan_ladder = " . $ladder_id;
	$result		= $db->sql_query ( $sql );
	$row		= $db->sql_fetchrow ( $result );
	$db->sql_freeresult ( $result );
	$new_rank	= $row[ 'current_rank' ] + 1;

	$sql_array	= array (
		'clan_id' => $clan->data[ 'clan_id' ],
		'clan_ladder' => $ladder_id,
		'clan_score' => 1200,
		'clan_current_rank' => $new_rank,
		'clan_best_rank' => $new_rank,
		'clan_worst_rank' => $new_rank,
		'clan_last_rank' => 0
	);
	$sql		= "INSERT INTO " . CLANDATA_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
	$db->sql_query ( $sql );

	// Completed. Let the user know.
	trigger_error ( 'JOINED_WITH_LADDER' );
}
else
{
	// Check to make sure the ladder is not locked.
	if ( $ladder->data[ 'ladder_locked' ] == 1 )
	{
		// Ladder is locked. Let the user know.
		trigger_error ( 'LADDER_JOIN_LOCKED' );
	}

	// The clan is wishing to leave the ladder.
	$sql	= "DELETE FROM " . CLANDATA_TABLE . " WHERE clan_ladder = $ladder_id AND clan_id = " . $clan->data[ 'clan_id' ];
	$db->sql_query ( $sql );

	// Completed. Let the user know.
	trigger_error ( 'LEFT_LADDER' );
}

?>
