<?php
##############################################################
# FILENAME  : tournaments_signup.php
# COPYRIGHT : (c) 2008, Tyler N. King <aibotca@yahoo.ca>
# http://opensource.org/licenses/gpl-license.php GNU Public License
##############################################################
if ( !defined ( 'IN_PHPBB' ) )
{
	exit;
}

$tournament		= new tournament ( );
$clan			= new clan ( );
$tournament_id	= request_var ( 'tournament_id', 0 );

// Check if the clan is joined to the ladder the tournament is in.
if ( $tournament->data[ 'tournament_ladder' ] != 0 && !in_array ( $tournament->data[ 'tournament_ladder' ], $clan->data[ 'clan_ladders' ] ) )
{
	// They are not. Let the user know.
	trigger_error ( 'CLAN_NOTSIGNED_UP_LADDER' );
}

// Get the list of tournaments the clan is in.
$sql	= "SELECT * FROM " . TCLANS_TABLE . " WHERE clan_id = {$clan->data[ 'clan_id' ]} AND clan_tournament = " . $tournament_id;
$result	= $db->sql_query ( $sql );
$row	= $db->sql_fetchrow ( $result );
$db->sql_freeresult ( $result );

// Are they already in this tournament?
if ( !empty ( $row[ 'clan_id' ] ) )
{
	// They are. Let the user know.
	trigger_error ( 'ALREADY_IN_TOURNAMENT' );
}

// Get the number of clans in the tournament.
$sql	= "SELECT COUNT(*) AS num_clans FROM " . TCLANS_TABLE . " WHERE clan_tournament = $tournament_id AND clan_bracket = 1";
$result	= $db->sql_query ( $sql );
$row	= $db->sql_fetchrow ( $result );
$db->sql_freeresult ( $result );

if ( $row[ 'num_clans' ] >= $tournament->data[ 'tournament_brackets' ] )
{
	// They can not join, the tournament is full. Let the user know. 
	trigger_error ( 'TOURNAMENT_FULL' );
}

// Everything is OK. Add them to the tournament.
$sql_array	= array (
	'clan_tournament' => $tournament_id,
	'clan_id' => $clan->data[ 'clan_id' ],
	'clan_bracket' => 1,
	'clan_position' => 0
);
$sql		= "INSERT INTO " . TCLANS_TABLE . " " . $db->sql_build_array ( 'INSERT', $sql_array );
$db->sql_query ( $sql );

// Add the tournament to the clan's data.
$tournaments	= unserialize ( $clan->data[ 'clan_tournaments' ] );
$tournaments[ ]	= $tournament_id;
$tournaments	= serialize ( $tournaments );

$sql	= "UPDATE " . CLANS_TABLE . " SET clan_tournaments = '$tournaments' WHERE clan_id = " . $clan->data[ 'clan_id' ];
$db->sql_query ( $sql );

// Completed. Let the user know.
trigger_error ( 'CLAN_SIGNED_UP' );

?>
